// Copyright YALI AMIT, January 15, 2001.

#ifndef FACECART_C
#define FACECART_C

// __________________________________________________________________________

#include <iostream>
#include <iomanip>
#include <cstdio>

#include "includes.h"
#include "landmark.h"
#include "pixel.h"
#include "image.h"
#include "detection.h"
#include "trainstat.h"
#include "carttree.h"
#include "ltatree.h"
#include "viewgrid.h"
#include "globals.h"
#include "detfuncs.h"
extern double ratios[];
extern detections tmpdetects;
extern ltatrees ltrees;
extern carttrees ctrees, ftrees;
extern igrid label_list;
extern int maxnumltas;
// __________________________________________________________________________
// Option 70
// Get a bunch of faces to build cart trees
static int compar(const void *a, const void* b);
void nistprocess(image &im);






void make_cart_images()
{
  int i, j;

//  dgrid meanim;
//  double varim;
//  meanim.read("meand");

  dgrids cartims;
  vector<image> imv( numdigits * numperts);

  ucgridss lands;
  if (cartstyle==0)
    cartims.init(numdigits * numperts);
  else
    lands.init(numdigits * numperts);
  igrid good;
  igrid matx;
  int numcl;

  // Prepare buffers to keep track of training data of
  // all classes hit by the detector
  if ( numperclass && numdata)  
    {
     if ( (numdata % numperclass) > 0)
          numperclass=0;
     else
       {
         matx.init(numdata);
         matx.clear();
         numcl=numdata/numperclass;
         cout << "numcl " << numcl << endl;
         good.init(numcl);
         good.clear();
       }
    }
  // Read and scale the registration points of the training images.
  igrid point1, point2, point3;
  

  igrids totlands;
 
  maxnumltas=numltas;
  // Calculate the fixed part of the registration transform.
  // The point[xy][12] variables are read from the parameter file.
  partialtrans fpt(Pixel(point1x, point1y), Pixel(point2x, point2y),
		   Pixel(point3x, point3y));
  
  int currim = 0;
  int count=0;
  ucgrid pmask;
  make_procmask(pmask, masktype, cartsizex, cartsizey);
 
  ifstream ifs("detcoords");
  ofstream ofs("label");
  image im;
  landmarks edgelands, ltalands;
  int oldimnum=-1;
  int coor[8];
  int c=0;
 
  while ( count < numdigits &&  (ifs >> coor[c++]))
    {

      if (c==8)
	{
	  c=0;
	  if (coor[0] >= 0)
	    {

              if (coor[6]!=oldimnum)  
		{
                  
		  if (numperclass > 0)
		    {
		      good( coor[6]/numperclass )++;
		      matx(coor[6])=1;
		    }

		  im.read(first+coor[6]);
		  if (nist)
		    nistprocess(im);
                  else
		  im.blur_downscale(ratio, sd);
		  //    view_normalized(im);
                  if (cartstyle>=2)
		    {
		      if (count>0)
			{
			  if(cartstyle==2)
			    empty_STAGS(edgelands);
			  if(cartstyle==3)
			    empty_STAGS(ltalands);
			}
                      if(cartstyle==2)
			onlyedges=1;
		      extract_landmarks(im, ltrees, numltas, 
					edgelands, ltalands);
                
                
		      if (cartstyle==2)
			fill_STAGS(edgelands, cartspread);
                      else if (cartstyle==3)
			fill_STAGS(ltalands, cartspread);

		    }
		  oldimnum=coor[6];
		}
		 
		  count++;

		  
		  
		  if (dum1 == 5)
		    view_normalized(im);
		  int pertcoor[6];
		  for (int jj = 0; jj < numperts; ++jj)
		    {
		     
			ofs << coor[7] << endl;
                      
		      for (int ii = 0; ii < 6; ++ii)
			{
			  pertcoor[ii] = coor[ii] + (rand() % pertamount) - pertamount / 2;
			  //     cout << pertcoor[ii] << " ";
			}

		      
		      register_image(im, fpt, cartims[currim], lands[currim],
				     pertcoor, 0,  cartstyle, 
				     cartsizex, cartsizey, 
				     pmask, leastsquares);
		   
		      if (cartstyle>=2)
			{

			  if (currim==0)
			    totlands.init(lands[0].dim());
			  for (int k=0; k<lands[0].dim(); k++)
			    {
			      if (currim==0)
				{
				  totlands[k].init(cartsizex,cartsizey);
				  totlands[k].clear();
				}
			      gridfun(totlands[k](i,j)+lands[currim][k](i,j),totlands[k]);
			      
			    }
			}
		      ++currim;
		    }
	    }
	}
    }      

  if (numperclass > 0)
    {
      ofstream gofs("good");
      for (int g=0; g<good.dimx(); g++)
          gofs << facenames[g] << " " << good(g) << endl;

      ofstream mofs("matx");
        for (int g=0; g<matx.dimx(); g++)
          mofs << matx(g) << endl;
       
    }
  
  if (cartstyle>=2 && showtriangles==1 )
    {
      for (int k=0; k<lands[0].dim(); k++)
	{
	  image uc(cartsizex, cartsizey);
	  gridfun( (unsigned char)(200*((double)totlands[k](i,j)/currim)),uc);
	  uc.normalize(imrange*numcolors, (1-imrange)*numcolors-1);
	  viewport vp(uc);
	  vp.view();
	}
    }
  if (cartstyle == 0) 
    {
      // TEMP
      // ofstream ofs("faces.dat");
      //for (int k=0; k<currim; k++)
      //{
      //  for (int i=0; i< cartims[k].dimx(); i++)
      //    for (int j=0; j<cartims[k].dimy(); j++)
      //	ofs << cartims[k](i,j) << " ";
      //  ofs << endl;
      //}
      write_dgrids(cartims, 0, currim, "cart");
    }
  else if (cartstyle==-1)
    write_images(imv,currim);
  else
    {
      ofstream ofs("cartraw");
      if (!ofs)
	{
	  cerr << "Unable to open cartraw\n";
	  exit(1);
	}
      
      for (i = 0; i < count * numperts; ++i)
	for (j = 0; j < lands[0].dim(); ++j)
	  lands[i][j].write(ofs);
    }
  
} // make_cart_images
  


// __________________________________________________________________________
// Option 71

void grow_carts()
{
  if (classlabel>=0)
     numclass=2;

  carthistsize=numclass;
  dgrids cartims;
  ucgridss lands;
  ifstream ifs("labels");

  if (ifs) 
    {
    label_list.init(numtrain);
    numbg=0;
    for (int i=0; i< numtrain; i++)
      {
      if (!(ifs >> label_list(i)))
	{
          cerr << "Not enough labels in labels\n";
          exit(1);
	}
      if (classlabel>=0)
	{
         
           if (classlabel==label_list(i))
	           label_list(i)=1;
	   else
	           label_list(i)=0;

	}
      else
	  label_list(i)-=first;
      }
    }

  //  cout << "numclass " << numclass << endl;
  //label_list.dump();
  if (cartstyle <= 1)
  {
    cartims.init(numtrain + numbg);
  }
  else
  {
    lands.init(numtrain + numbg);
    int numl;
    if (cartstyle == 2)
      numl = numedges;
    else
      numl = numltas;
    for (int i = 0; i < lands.dim(); ++i)
      lands[i].init(numl);
  }

  get_cart_train_good(cartims, lands, cartstyle, 
		      "ftrraw", 0, numtrain);
  get_cart_train_good(cartims, lands, cartstyle,
		      "ftsraw", numtrain, numbg);

  lgrid dlist;
  numtreedata = numtrain + numbg;
  dlist.init(numtreedata);
  int i;
  for (i = 0; i < numtreedata; ++i)
    dlist(i) = i;
  dgrid agg;
  //if (!buildtree)
    {
    agg.init(numtreedata, numclass);
    agg.clear();
    }
  for (i = 0; i < numcarts; ++i)
  {
    carttree ftree;

    if (buildtree)
      {
	ftree.grow(dlist, cartims, lands);
	ftree.write(simpstrg("ctree") + ltos(i + firsttree));
      }
    //    else
      {
	if (!ftree.read(carttreedir + simpstrg("/ctree") + ltos(i))) 
	  {
	    cerr << "Unable to read in carttrees.\n";
	    exit(1);
	  }
	ftree.drop(cartims, lands, agg);
      }
  }

  //if (!buildtree)
    {
      double correct=0;

      for (int i=0; i<agg.dimx(); i++)
	{
	  dgrid temp(2,numclass);
	  for (int j=0; j<numclass; j++)
	    {
	      temp(0,j)=agg(i,j);
	      temp(1,j)=j;
	      //cout << agg(i,j) << " ";
	    }
	  //cout << endl;
	  temp.sort_columns(numclass,compar);
	  if (temp(1,0)==label_list(i))
	    correct++;
	}
      cout << "CORRECT " << correct/agg.dimx() << endl;
    }
	

         
} // grow_cart

static int compar(const void *a, const void* b)
{
  return (*((const double*) a) < *((const double*) b));
}

void get_cart_train_good(dgrids& cartims, ucgridss& lands, int cstyle,
                         const char* cfr, int cstart, int nd)
{
  if (nd == 0)
    return;

  int i, j;
  if (cstyle <= 1)
  {
    Ifstream(ifs, cfr);
    if (!ifs)
    {
      cerr << "Unable to open " << cfr << endl;
      exit(1);
    }

    for (i = cstart; i < cstart + nd; ++i)
      {
	if (!cartims[i].read(ifs))
	  {
	    cerr << " cant read data point " << i << endl;
            exit(1);
	  }
      }
  }
  else
  {
    Ifstream(ifs, cfr);
    if (!ifs)
    {
      cerr << "Unable to open " << cfr << endl;
      exit(1);
    }
    int numl;
    if (cstyle == 2)
      {
      numl = numedges;
      if (wholecarts)
        numl=numedges/2;
      }
    else
      numl = numltas;
    for (i = cstart; i < cstart + nd; ++i)
      for (j = 0; j < numl; ++j)
	{
	lands[i][j].read(ifs);
	if (i==dum2)
	  view_normalized(lands[i][j]);
    	}
  }

} // get_cart_train_good



void write_dgrids(dgrids& regims, int first, int numdigits, char* name)
{
  ucgrid processmask;
  if (dum1 == 50)
    make_procmask(processmask, masktype, cartsizex, cartsizey);

  // Write out a grid file showing the registered images.
  int i, j, k;
  ofstream ofs(simpstrg(name) + "raw");
  for (i = first; i < first + numdigits; ++i)
  {
   
    dgrid u = regims[i];
    for (j = 0; j < u.dimx(); ++j)
      for (k = 0; k < u.dimy(); ++k) {
        if (u(j, k) < -3) u(j, k) = -3;
        if (u(j, k) > 3) u(j, k) = 3;
        if (dum1 == 50 && !processmask(j, k))
          (u(j, k) = 3);
      }
    u.write(ofs);
  }

} // write_dgrids


// facecartc.C

#endif // FACECART_C






