// Copyright YALI AMIT, January 15, 2001.

#define MAIN_C


// __________________________________________________________________________
// Include files

#define MAIN_DEFINED

#include "includes.h"

#include <iostream>
#include <iomanip>
#include <fstream>
#ifndef NOX
//#include <unistd.h>
#endif
#include <ctime>

#include "simpstrg.h"
#include "histgram.h"
#include "facecart.h"
#include "detection.h"
#include "trainstat.h"

#include "ltatree.h"
#include "carttree.h"
#include "viewgrid.h"
#include "viewport.h"
#include "globals.h"

#define log2(a) log((double)a)/log(2.)


#ifndef MINMAX
#define MINMAX
#define max(a,b) (((a)>(b))?(a):(b)) 
#define min(a,b) (((a)>(b))?(b):(a)) 
#endif

igrid label_list;
ucgrids STAGS(300);
ucgrids edgemats(8);

igrid LOCS;
igrid relmasksx, relmasksy;
double ratios[] = { 1.0, 0.75, 0.56, 0.42, 0.32, 0.24, 0.18, 0.14, .1, .075 };
//double ratios[] = { 1.0, 0.5, 0.25};

ltatrees ltrees;
carttrees ctrees, ctreesw, ftrees;
images IMV;
int CURRDET, CURRIM;
extern int PRI;
void hack2();
void hack3();
void hack4();
void hack5();
extern dgrid weits;

vector<igrid> digitLists;

// __________________________________________________________________________

int main(int argc, char** argv)
{
  // Determine if there is a parameter file.  If yes, read in the
  // values of global parameters from it.
  get_parfile(argc, argv, parfile);
  if (parfile != "" && !parse_parfile(parfile))
  {
    cerr << "Unable to open parameter file [" << parfile << "].\n";
    exit(1);
  }

  // Determine the values for globals parameters set on the command
  // line.
  parse_argv(argc, argv);
  
  // Seed the random number generator.
  if (seed == 0)
    seed = time(0);
  
  //   cout << seed << endl;
  srand((int)seed);
  srand48((int)seed);
  //cout << rand() << endl;

  // New parameter  still not adjusted in all scripts
  if (EdgeRadius < 5)
    EdgeGoodTests=EdgeRadius;
  
  // Dump the values of global variables to the dumpfile.
  dump_globals(dumpfile);

  // Set the impurity function
  set_impurity_func(impmeasure, 0);

  // Set up some other global variables
  if (near>0)
  make_rel_masks();

  // Perform the desired option.
  switch (opt) {
   case 0:
    cout << "No option specified.  Possible options are:\n";
    cout << "  1 - Grow a tree.\n";
    cout << "  2 - Read an lta tree.\n";
    cout << "  4 - Drop data down an existing tree, aggregate results.\n";
    cout << "  5 - Read an aggregate results files.\n";
    cout << "  6 - Same as option 5, but write out bad digits to a listfile."
	 << "\n";
    cout << "  7 - Same as option 6, but write out histogram as well.\n";
    cout << "  8 - Get statistics about an aggregate file.\n";
    cout << "  9 - Make a reject aggregate file.\n";
    cout << " 10 - Write out a bunch of codes from a list of images.\n";
    cout << " 11 - View a bunch of codes extracted using option 10.\n";
    cout << " 12 - Create a landmark file.\n";
    cout << " 13 - Dump an entry from a landmark file.\n";
    cout << " 15 - Treestats.\n";
    cout << " 20 - View a listfile of images (up to 400).\n";
    cout << " 21 - View a listfile of images, one at a time.\n";
    cout << " 30 - NN test for aggregate files.\n";
    cout << " 31 - Add two aggregate files together.\n";
    cout << " 40 - View a bunch of faces, one at at time.\n";
    cout << " 41 - View a bunch of faces, all at once.\n";
    cout << " 42 - Determine average coordinates of training images.\n";
    cout << " 43 - Calculate registered images.\n";
    cout << " 44 - Make edge maps.\n";
    cout << " 45 - Transform edge maps.\n";
    cout << " 46 - Make lta trees.\n";
    cout << " 47 - Make latex image data.\n";
    cout << " 51 - Process a pgm image\n";
    cout << " 61 - View a grid or pgm file.\n";
    cout << " 82 - Read a cart tree.\n";
    cout << " 84 - View lta positions.\n";
    cout << " 85 - Find a bunch of good lta trees.\n";
    cout << " 86 - Extract subimages for training features.\n";
    cout << " 87 - View an lta.\n";
    cout << " 95 - Create a big file, save as Images_0.\n";
    cout << " 96 - Write out pic0.pgm, ... into an Images_ file.\n";
    cout << "501 - Display stats for a range of image.\n";
    cout << "502 - Print summary information for a bunch of landmarks\n";
    cout << "504 - Summarize land mark info.\n";
    cout << "600 - Test the random number routine.\n";
    exit(0);
    break;


  case 1000:
    { 
      void make_tag_files();
      make_tag_files();

    }
    break;

  case 1001:
    {
      Ifstream(ifs, listfile);
      int indices[400], count = 0;
      if (ifs) {
	while (ifs >> indices[count] && ++count < 400)
	  ;
      }

      images IMV(count);
      for (int k=0; k< count; k++)
	{
	  image im;
	  im.read(indices[k]);
	  //cview_normalized(im);
	  IMV(k)=im;
	}
      write_images(IMV,count);
    }
    break;  
    
   case 1: {
     ltatree dtree;
     for (int i = 0; i < numltas; ++i) {
       dtree.read(ltatreedir + simpstrg("/tree") + ltos(i + firstlta));
       numang = dtree.tnumang;
       near = dtree.tnear;
       dtree.clearhists(dtree.top());
       dtree.update();
       dtree.write(simpstrg("tree") + ltos(i + firstlta));
     }
   }
   break;

   case 2: {
     ltatree dtree;
     if (dtree.read(treefile))
       dtree.dump();
   }
   break;

   case 13: {
     landmarks l;
     l.read(first);
     l.dump();
   }
   break;

  case 3:
    {
      void old_to_new_ltatrees();
      old_to_new_ltatrees();
    }
   break;
   case 15: {
     int count = first, done = 0;
     ltatreestats total;
     while (!done && count <= last) 
     {
       simpstrg treename = simpstrg("tree") + ltos(count);
       ltatree dt;
       dt.stats = new ltatreestats;
       done = !dt.read(treename);
       if (!done)
       {
         cout << ".";
         cout.flush();
         if ((count - first + 1) % 78 == 0)
           cout << endl;
         dt.calc_stats(dt.top());
         total += *(dt.stats);
         ++count;
       }
     }
     cout << "\nAverages based on " << count - first << " tree(s)\n";
     total.dump(count - first);
   }
   break;

   case 70:
    make_cart_images();
    break;

   case 71:
     grow_carts();
    break;




   case 81:
    void  get_all_q1();
    get_all_q1();
    break;

   case 82: {
     carttree dtree;
     if (dtree.read(treefile))
       dtree.dump();
   }
   break;

  case 83:
    {
     for (int j=0; j<numltas; j++)
       {
	 void  get_rand_q1(int nn);
	 get_rand_q1(j);
       }
    }
    break;

 
  case 84:
    {
      //void estimate_temps();
      //      estimate_temps();
    }
    break; 


// __________________________________________________________________________
// Below here are cases that require X to compile




   // Separate out nist classes
  case 28:
   {
     void get_edgetemps();
     get_edgetemps();
     break;
   }
  case 29:
    {
      hack2();
      break;
    }
   break;
 case 40:
   {
     void viewim();
     viewim();
     break;
   }
  case 30:
    {
      //void naive_train();
      //naive_train();
      void nearest_neighbors();
      nearest_neighbors();
      break;
    }
   break;
   case 31:
   {
     void naive_test();
     naive_test();
   }
   break;

   case 41:
     void view_many_images();
     view_many_images();
    break;

   case 42:
    get_coord_stats();
    break;

   case 43:
    register_images();
    break;

   case 44:
    make_edge_maps();
    break;

   case 45:
    transform_edge_maps();
    break;

   case 46:
    make_ltas();
    break;

   case 47:
     {
       void make_latex_images();
    make_latex_images();
    break;
     }
  case 48:
    {
      void make_tag_tree();
      make_tag_tree();
      break;
    }
   case 49:
     {
       void test_images();
       test_images();
       break;
     }

  

   case 51:
   {
     void detect();
     detect();
   }
   break;
   case 52:
     view_raw_grids();
     break;
  case 53:
    {
      if (last==0) 
	last = first + numdigits - 1;
      void viewedges();
      viewedges();
      break;
    }
  case 148:
    void grow_class(int numtrees); 
    grow_class(numcarts);
    break;
  
  case 149:
    void drop_class(int numtrees);
    drop_class(numcarts);
    break;
  case 147:
    void drop_class_quick(int numtrees);
    drop_class_quick(numcarts);
    break;
 
   case 85:
    find_good_trees();
    break;

  case 86:
    {
     void get_subregions();
     get_subregions();
     break;
    }

   case 87:
    view_ltas();
    break;

   case 88:
    get_mean_edgemap();
    break;

   case 89:
    get_lta_maps();
    break;

  case 94: {
     vector<image> im(numdata);
     if (regionsize < 10)
       regionsize = 200;
     void makevec(int N);
     if (synthesize==1)
      makevec(base);  
     for (int i = 0; i < numdata; i++)
              im[i].make_big(regionsize, regionsize, datasize, numdigits, 
                     first, last);
     write_images(im, numdata);

   }
   break;


   

   case 96: {
     vector<image> im;
     if (listfile=="")
       {
	 im.init(numdigits);
	 for (int i = 0; i < numdigits; ++i) 
	   {
	   im[i].read(simpstrg("pic") + ltos(i) + simpstrg(".pgm"));
	   if (dum1>=0)
	     im[i].set_truth(dum1);
	   else 
	     im[i].set_truth(i);
	   }
       }
     else
       {
	 ifstream ifs(listfile);
	 char buf[255];
	 numdigits=0;
	 while (ifs.Getline(buf, 255))
	   numdigits++;
	 ifs.close();
	 im.init(numdigits);
	 ifs.open(listfile);
	 for (int i=0; i<numdigits; i++)
	   {
	     ifs.Getline(buf, 255);
	     im[i].read(simpstrg(buf));
	     if (dum1>=0)
	       im[i].set_truth(dum1);
	     else 
	       im[i].set_truth(i);
	   }
       }

     //view_normalized(im[0]);
     write_images(im, numdigits);
   }
   break;

  

  
 
 

   case 111: {
     void twod_el();
     twod_el();
   
    break;
   }
   case 112: {
     void init_dynamic(image &im);
     image im;
     im.read(first);
     init_dynamic(im);
    }
    break;

   case 113: {
     void init_defcont(image &im);
     image im;
     im.read(first);
     init_defcont(im);
    }
    break;

   case 114: {

    void synth();
    synth();
    break;
   }
  

   case 115: {
     image im, ims;
     for (int i=first; i<last; i++)
       {
	 im.read(i);
	 im.blur_downscale(ratio, sd);
	 void twod_els(image &im);
	 twod_els(im);
       }
    } 
    break;
  case 116: {
     void dy(image &im);
     image im;
     for (int i=first; i<last; i++)
       {
	 im.read(i);
	 im.blur_downscale(ratio, sd);
	 dy(im);
       }
  }
    break;
  case 117: {
      void roadtrack(image &im);
     image im;
     for (int i=first; i<last; i++)
       {
	 im.read(i);
	 im.blur_downscale(ratio, sd);
	 roadtrack(im);
       }
  }
    break;

  case 199: {
    // Test get_dig_list
    void get_dig_list(lgrid &loclist, int numloc, lgrid &datalist);

    lgrid loclist(numloc);
    int nnd=numdigits;
    weits.init(nnd);
    lgrid data(nnd);

    for (int i=0; i<nnd; i++) {
      data(i)=i;
    }

    for (int i=0; i<nnd-1; i++) {
      weits(i)=(double)1.0/1000000;
      cout << weits(i) << ", ";
    }
    weits(nnd-1)=1;
    cout << weits(nnd-1) << endl;
    
    for (int i=0; i<10000; i++) {
      get_dig_list(loclist, numloc, data);
      for (int j=0; j<numloc-1; j++) {
	cout << loclist(j) << ", ";
      }
      cout << loclist(numloc-1) << endl;
    }
  }
    break;

 

  case 1010:{
    void makewaves();
    makewaves();
    break;
  }

// __________________________________________________________________________
// Handle default case and end main.

   default:
    cerr << "Invalid option [" << opt << "] chosen." << endl;
    break;

  }
  return 0;
  
} // main

// __________________________________________________________________________
// main.C

