// Copyright YALI AMIT, January 15, 2001.


// __________________________________________________________________________
// Includes

#include "includes.h"
#include "question.h"
#include "avlgrid.h"
#include "ltatree.h"
#include "globals.h"
#include "viewgrid.h"
#include "viewport.h"
extern ucgrids STAGS;
extern ucgrids edgemats;
extern dgrid weits;
extern ucgridss EMATSS;
void get_best_q0(question& que, lgrid& qlist, lgrid& dlist, 
		 const lmarkslist& lmarks, double& ent); 
int check_q0(relation& rel, const landmarks& lmarks, int ii=-1);



void get_best_q0(question& que, lgrid& qlist, lgrid& dlist, 
		 const lmarkslist& lmarks, double& ent)
{
  if (qlist.dimx() == 0)
    return;


  int index = 0;
  int counter = 0;
  relation rel;
  rel.dis=cartsizex;
  rel.tol=cartspread;
  rel.ang=near;
    for (rel.land2=0; rel.land2 < cartsizex*cartsizex; ++rel.land2)
      for (rel.land1 = minland; rel.land1 < minland + numland; ++rel.land1)
      {
	if (index == qlist.dimx())
	  return;
	else if (qlist(index) == counter++)
	    {
               
	      // cout << rel.land2 << " " << rel.land1 << " " ;

	      ltahist yes, no;
	      for (int i = 0; i < dlist.dimx(); ++i)
		{
		  if (check_q0(rel, lmarks[dlist(i)], dlist(i)))
		    {
		    if (boost)
		      yes[lmarks[dlist(i)].truth(nist)]+=weits(dlist(i));
		    else
		      ++yes[lmarks[dlist(i)].truth(nist)];
		    }
		  else
		    {
		    if (boost)
                     no[lmarks[dlist(i)].truth(nist)]+=weits(dlist(i));
		    else
		      ++no[lmarks[dlist(i)].truth(nist)];

		    }
		}
              
	      double newent;
	      if (class_tree==0)
		newent = 1000000 - yes.total();
              else
                newent = ave_impurity(yes, no);
	      //	      cout << " newent " << newent << " " << ent << " " << yes.total() << " " << no.total() << " " << endl;
	      if (newent < ent-.00001) {
		ent = newent;
		que.typ = 10;
		que.r1 = rel;

		if (no.total() == 0)
		  return;

                  
	      }
	      ++index;
	    }
	 
      }
 


  
} // get_best_q0


//___________________________________________________________________________
int check_q0(relation& rel, const landmarks& lmarks, int ii/*=-1*/)
{
  int found=0;
      int l2x = rel.land2 / (int)rel.dis;
      int l2y = rel.land2 % (int)rel.dis;
      /*
      if (spread==0)
	{
	  int num1 = lmarks.type_count(rel.land1);
  	  for (int i = 0; i < num1 && found==0 ; ++i)
	    {
	      int l1x = lmarks.location_x(rel.land1, i) / int(rel.tol);
	      int l1y = lmarks.location_y(rel.land1, i) / int(rel.tol);
	      if ( fabs(l1x-l2x) < rel.ang && fabs(l1y-l2y) < rel.ang )
		found=1;
	    }
	}
      else if (spread!=0)
      */
	{
	  if (ii==-1)
	    found=STAGS[rel.land1](l2x,l2y);
	  else
	    found=(EMATSS[ii][rel.land1](l2x,l2y));
	}
      return found;

} // check_q0









