// Copyright YALI AMIT, January 15, 2001.
#define QALL_C

// __________________________________________________________________________
// Includes


#include "includes.h"
#include "question.h"
#include "avlgrid.h"
#include "ltatree.h"
#include "globals.h"

extern ucgrids STAGS;

int ltas(ltaiter iter, const landmarks& lmarks, igrid& instances)
{
  static igrid tmpinsts;
  static ivector l(2);

  ucgrid loctemp(STAGSdim/ltacluster, STAGSdim/ltacluster);
  loctemp.clear();
  //cout << " ltas " <<  endl;  
  static int inited = 0;
  if (!inited) 
  {
    inited = 1;
    tmpinsts.init(q1insts, 2);
  }


  igrid edg(ltausedepth*2);
  igrid ang(ltausedepth*2);
  edg[0]=iter->que.r1.land1;
  edg[1]=iter->que.r1.land2;
  ang[0]=iter->que.r1.ang;
  ltaiter siter=iter.yes();
  int ie=2; int ia=1;
  while (siter.branch())
    {
      edg[ie]=siter->que.r1.land1;
      ang[ia]=siter->que.r1.ang;
      ia++;
      ie++;
      siter=siter.yes();
    }
  //edg.dump();
  //ang.dump();
  int foundinst = 0;
  // Loop through all occurrence of landmarks of type 1
  int num1 = lmarks.type_count(edg[0]);
  for (int i = 0; i < num1; ++i)
  {
    l[0] = lmarks.location_x(edg[0], i);
    l[1] = lmarks.location_y(edg[0], i);
    int clx=l[0]/ltacluster; 
    int cly=l[1]/ltacluster;
    if (loctemp(clx,cly))
      continue;
    int found=1;
    
    ucgrid temp(2 * near + 1, 2*near + 1);
    temp.clear();
    for (int ii=1; ii<=ia && found && foundinst < maxinst; ii++)     
      {
      int foundstep=0;
      int searchpix = relmasksx(ang[ii-1], 0);
      for (int j = 1; j < searchpix && !foundstep; ++j)
	{
	  
          int dx = relmasksx(ang[ii-1],j);  
          int dy = relmasksy(ang[ii-1],j);  
	  int x = l[0] + dx;
	  int y = l[1] + dy;
	  if(!temp(near+dx,near+dy) )
	     {
	       if (STAGS[edg[ii]].get(x,y))
		 {
		   foundstep=1;
		   temp(near+dx, near+dy)=1;
		 }
	     }
	}
      if (!foundstep)
         found=0;
      }
      if (found)
	{       
	  loctemp(clx,cly)=1;
	  // cout << " <<found  " << l[0] << " " << l[1] << endl;
	  for (int ii = 0; ii < 2; ++ii)
	    tmpinsts(foundinst, ii) = l[ii];
	  ++foundinst;
	}
  }
    
  if (foundinst)
    {
      instances.init(2, foundinst);
      for (int i = 0; i < 2; ++i)
	for (int j = 0; j < foundinst; ++j)
	  instances(i, j) = tmpinsts(j, i);
    }
  //  cout << "FOUND " << foundinst << endl;
  return foundinst;
  
}

// __________________________________________________________________________
// qall.C



