// Copyright YALI AMIT, January 15, 2001.

#define QUESTION_C


#include "includes.h"
#include "grid.h"
#include "question.h"
#include "globals.h"
#include "viewport.h"

// __________________________________________________________________________

void question::write(ostream& os)
{
  varwrite(os, typ);
  switch (typ)
  {
   case 0:
    break;
    
  case 1:
  case 10:
  case 5:
    varwrite(os, r1.land1);
    varwrite(os, r1.land2);
    varwrite(os, r1.ang);
    varwrite(os, r1.tol);
    varwrite(os, r1.dis);
    break;

   case 2:
  case 6:
    varwrite(os, r1.v1);
    varwrite(os, r1.land1);
    varwrite(os, r1.ang);
    varwrite(os, r1.tol);
    varwrite(os, r1.dis);
    break;

    case 3:
    varwrite(os, r1.v1);
    varwrite(os, r1.v2);
    varwrite(os, r1.land1);
    varwrite(os, r1.land2);
    break;
   
 
   case 4:
    varwrite(os, r1.v1);
    varwrite(os, r1.v2);
    varwrite(os, r1.land1);
    break;

    // case 7 added by Elliot - 4/24/02
  case 7:
    varwrite(os, r1.land1);
    varwrite(os, r1.land2);
    varwrite(os, r1.ang);
    varwrite(os, r1.tol);
    varwrite(os, r1.dis);
    varwrite(os, r1.v1);
    varwrite(os, r1.v2);
    break;
    
   default:
    cerr << "Unable to write question type [" << typ << "]\n";
    exit(1);
    break;

  }

} // question::write

// __________________________________________________________________________

void question::read(istream& is)
{

  varread(is, typ);
  switch (typ)
  {
   case 0:
    break;

   case 1:
  case 10:
  case 5:
    varread(is, r1.land1);
    varread(is, r1.land2);
    varread(is, r1.ang);
    varread(is, r1.tol);
    varread(is, r1.dis);
    break;

   case 2:
  case 6:
    varread(is, r1.v1);
    varread(is, r1.land1);
    varread(is, r1.ang);
    varread(is, r1.tol);
    varread(is, r1.dis);
    break;

  case 3:
    varread(is, r1.v1);
    varread(is, r1.v2);
    varread(is, r1.land1);
    varread(is, r1.land2);
    break;
   
 
   case 4:
    varread(is, r1.v1);
    varread(is, r1.v2);
    varread(is, r1.land1);
    break;

    // Case 7 added by Elliot - 4/24/02
    case 7:
    varread(is, r1.land1);
    varread(is, r1.land2);
    varread(is, r1.ang);
    varread(is, r1.tol);
    varread(is, r1.dis);
    varread(is, r1.v1);
    varread(is, r1.v2);
    break;

   default:
    cerr << "Unable to read question type [" << typ << "]\n";
    exit(1);
    break;

  }

} // question::read

// __________________________________________________________________________

void make_rel_masks()
{
void make_rel_masks_new();
 if (simple==1)
   {
   make_rel_masks_new();
   return;
   }
  relmasksx.init(numang, 4 * (near + 1) * (near + 1));
  relmasksy.init(numang, 4 * (near + 1) * (near + 1));
  double reltolerance = 2 * PI / numang;
  double anginc = 2 * PI / numang;
  for (int ang = 0; ang < relmasksx.dimx(); ++ang)
  {
    double currang = ang * anginc;
    int pix = 1;
    for (int i = -near; i <= near; ++i)
      for (int j = -near; j <= near; ++j)
      {
	if (abs(i) < separation && abs(j) < separation)
	  continue;
	double pixang = atan2(-j, i);
	if (pixang < 0)
	  pixang += 2 * PI;
	if (fabs(currang - pixang) <=  reltolerance + FUZZ ||
	    fabs(2 * PI + currang - pixang) <= reltolerance + FUZZ ||
	    fabs(2 * PI + pixang - currang) <= reltolerance + FUZZ)
	{
	  relmasksx(ang, pix) = i;
	  relmasksy(ang, pix) = j;
	  ++pix;
	}
      }
    relmasksx(ang, 0) = pix;
    //cout << "PIX " << pix << endl;
  }
  void view_rel_masks();
  if (dum1==100)
    view_rel_masks();

} // make_rel_masks


void make_rel_masks_new()
{

 numang=2*(near+2)+2*near;
 cout << numang << endl;
  relmasksx.init(numang, near*near+1);
  relmasksy.init(numang, near*near+1);
  int ang=0;
  for (int bx=-near; bx<=1; bx++)
    for (int by=-near; by<=1; by++)
      {
        int pix=1;
	if (bx<=0 && bx+near >0 && by<=0 && by + near>0 )
           continue;
	     for (int i = 0; i < near; ++i)
	       for (int j = 0; j < near; ++j)
		 {
		   relmasksx(ang, pix) = bx+i;
		   relmasksy(ang, pix) = by+j;
		   ++pix;
		 }
	relmasksx(ang, 0) = pix;
	ang++;

      }
      


  void view_rel_masks();
  if (dum1==100)
    view_rel_masks();

} // make_rel_masks

// __________________________________________________________________________

void view_rel_masks()
{
  viewport vp;
  cout << " near " << near << endl;
  for (int ang = 0; ang < relmasksx.dimx(); ++ang)
  {
    cout << "\nmask " << ang << endl;
    ucgrid tmp(near * 2 + 1, near * 2 + 1);
    tmp.clear();
    for (int pix = 1; pix < relmasksx(ang, 0); ++pix)
      {
      tmp(relmasksx(ang, pix) + near, relmasksy(ang, pix) + near) = 1;
      //cout << relmasksx(ang, pix) << " " << relmasksy(ang,pix) << endl;
      }
    cout << relmasksx(ang,0) << endl;
    tmp.normalize(numcolors-1);
    vp.add_grid(tmp);
    vp.view();
  }

} // view_rel_masks


int newcheck(int dx, int dy, relation& rel)
{
  if ( abs(dx) >= separation || abs(dy) >= separation)
    {
      if (abs(dx) <= near && abs(dy) <= near)
	{
	  double currang = rel.ang * anginc;
	  double pixang = atan2(-dy,dx);
	  if (pixang < 0)
	    pixang += PI2;
	  if (fabs(currang - pixang) <=  reltolerance + FUZZ ||
	      fabs( PI2 + currang - pixang) <= reltolerance + FUZZ ||
	      fabs( PI2 + pixang - currang) <= reltolerance + FUZZ)
	    return 1;
	}
    }
  return 0;
}
// __________________________________________________________________________
// question.c
