// Copyright YALI AMIT, January 15, 2001.

#ifndef VIEWGRID_C
#define VIEWGRID_C



// __________________________________________________________________________

#include <iostream>
//#include <sys/types.h>


#define String XString

#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#undef String

#include "includes.h"
#include "grid.h"
#include "viewgrid.h"
#include "viewport.h"
#include "globals.h"
#include "image.h"
#include "detection.h"
#include "ltatree.h"

// __________________________________________________________________________
int read_coords(igrid& point1, igrid& point2, igrid& point3, double scale, int ff, int ll);
 void nistprocess(image &im);
void viewim()
{
  igrid point1, point2, point3;
  int exist = read_coords(point1, point2, point3, ratio, first, first+numdigits);
  
  image im;
  viewport vp(im);
  for (int i = 0; i < numdigits; ++i)
    {
      if (im.read(i+first))
	{
	  
	  if (dum1 == 5) {
	    cout << "dimensions " << im.dimx() << " " 
		 << im.dimy() << endl;
	    cout << " Truth " << im.truth() << endl;
	  }
	  vp.clear_geom();
	  if (nist)
	    { 
	     
	      nistprocess(im);
	    }
	  else 
	    im.blur_downscale(ratio, sd);
	  
	  if (dumpdetections==1) {
	    cout << "dimensions " << im.dimx() << " " 
		 << im.dimy() << endl;
	    cout << " Turth " << im.truth() << endl;
	  }
	  if (exist)
	    {
	      if (showtriangles==1)
		{
		  cout << point1(i,0) << " " << point1(i,1) << endl;
		  cout << point2(i,0) << " " << point2(i,1) << endl;
		  cout << point3(i,0) << " " << point3(i,1) << endl;
		  vp.add_point(point1(i, 0), point1(i, 1), basecol,4);
		  vp.add_point(point2(i, 0), point2(i, 1), basecol,4);
		  vp.add_point(point3(i, 0), point3(i, 1), basecol,4);
		}
	      if (showtriangles==2)
		{
		  cout << point1(i,0) << " " << point1(i,1) << endl;
		  cout << point2(i,0) << " " << point2(i,1) << endl;
		  cout << point3(i,0) << " " << point3(i,1) << endl;
		  vp.add_line(point1(i, 0), point1(i, 1), point2(i, 0),
			      point2(i, 1), basecol);
		  vp.add_line(point2(i, 0), point2(i, 1), point3(i, 0),
			      point3(i, 1), basecol);
		  vp.add_line(point3(i, 0), point3(i, 1), point1(i, 0),
			      point1(i, 1), basecol);
		}
	    
	    }
	  if (showtriangles<=2)
	    {
	      im.normalize(imrange*numcolors, (1-imrange)*numcolors - 1);
	      vp.upd_grid();
	      vp.view();
	    }
	}
    }
}

void view_many_images(const igrid& inds, int numdig) {
  
  viewport vp;
  Ifstream(ifs, listfile);
  int indices[400], count = 0;
  
  count = MIN(400,numdig);
  for (int i = 0; i < count; ++i)
    indices[i] = inds(i);
  
  pixsize = 1;
  int numperrow = MIN(last,count);
  int boxsize = (int)scale;
  int isize = numperrow * (boxsize);
  int numrow = ((count % numperrow) ? (count/numperrow)+1 : count/numperrow);
  int jsize = (numrow * boxsize);
  
  ucgrid bigimage(isize, jsize);
  bigimage.clear();
//   cout << numperrow << endl;
  cout << "Displaying " << count << " images, " 
       << numperrow << " per row." << endl;
  for (int i=0; i<count; i++) {
//     cout << i << endl;
    image tmpimage;
    tmpimage.read(indices[i]+first);
    if (nist)
      nistprocess(tmpimage);
    else
      tmpimage.blur_downscale(ratio, sd);         
    int starty = (i / numperrow) * (boxsize);
    int startx = (i % numperrow) * (boxsize);
    vp.add_line(startx, starty, startx + boxsize, starty, basecol);
    vp.add_line(startx, starty, startx, starty + boxsize,basecol);
    vp.add_line(startx+boxsize, starty, startx + boxsize, starty+boxsize,
		basecol);
    vp.add_line(startx, starty+boxsize, startx+boxsize, starty + boxsize,
		basecol);
    
    for (int ii = 0; ii < boxsize; ++ii)
      for (int j = 0; j < boxsize; ++j)
	bigimage(startx + ii, starty + j) = tmpimage.get(ii, j);
    
  }
  bigimage.normalize(numcolors-1);
  vp.add_grid(bigimage);
  vp.view();
  
} // view_many_images(const igrid&)

void view_many_images() {

  Ifstream(ifs, listfile);
  igrid indices(400);
  int count = 0;

  if (ifs) {
    while (ifs >> indices[count] && ++count < 400);
  }
  else {
    count = MIN(400,numdigits);
    for (int i = 0; i < count; ++i)
      indices[i] = i;
  }

  view_many_images(indices, count);
    
}

void view_grid(const ucgrid& gr, int gfork)
{
  if (gfork && fork())
    return;

  viewport vp(gr);
  vp.view();

  if (gfork)
    exit(1);
  else
    return;

} // view_grid

// __________________________________________________________________________

void view_normalized(const ucgrid& gr, int gfork, int min, int max)
{
  if (gfork && fork())
    return;

  ucgrid vgr = gr;
  if (max == 0)
    max = numcolors - 1;
  vgr.normalize(min, max);
  viewport vp(vgr);
  vp.view();

  if (gfork)
    exit(1);
  else
    return;

} // view_normalized

// __________________________________________________________________________

void view_dnormalized(const dgrid& gr, int gfork, int min, int max)
{
  if (gfork && fork())
    return;

  dgrid dgr = gr;
  dgr.normalize(0.1, numcolors - 1.1);

  ucgrid vgr;
  vgr.init(dgr.dimx(), dgr.dimy());
  for (int i = 0; i < dgr.dimx();  ++i)
    for (int j = 0; j < dgr.dimy(); ++j)
      vgr(i, j) = uchar(dgr(i, j));

  viewport vp(vgr);
  vp.view();

  if (gfork)
    exit(1);
  else
    return;

} // view_dnormalized

// __________________________________________________________________________
// View all, or up to 'numdigits', normalized grids stored in a 
// binary file of dgrids.

void view_raw_grids()
{
  Ifstream(ifs, listfile);

  dgrid dim;
  if (!dim.read(ifs))
    exit(1);

  int dimx = dim.dimx();
  int dimy = dim.dimy();

  int ind = 0;
  while (dim.read(ifs))
    ++ind;
  ifs.close();
  ifs.Open(listfile);

  if (numdigits > 1 && numdigits < ind)
    ind = numdigits;

  int size = int(sqrt(ind) + 1);

  ucgrid im((dimx + 2) * size, (dimy + 2) * size);
  im.clear(numcolors / 2);
  int startx = 1, starty = 1;
  for (int i = 0; i < ind; ++i)
  {
    if (!dim.read(ifs)) { cerr << "Oops\n"; exit(1); }
    for (int j = 0; j < dimx; ++j)
      for (int k = 0; k < dimy; ++k)
	im(j + startx, k + starty) = uchar(numcolors / 6 * dim(j, k) + 
                                           numcolors / 2);
    startx += dimx + 2;
    if (startx + dimx > im.dimx())
    {
      startx = 1;
      starty += dimy + 2;
    }
  }
  view_normalized(im);

} // view_raw_grids

// __________________________________________________________________________

void refresh_views(viewports& vps)
{
  for (int i = 0; i < vps.dim(); ++i)
    vps[i].refresh();

} // refresh_views

// __________________________________________________________________________

void view_views(viewports& vps)
{
  int viewing = 1;
  while (viewing) {
    for (int i = 0; viewing && i < vps.dim(); ++i)
      viewing = vps[i].refresh();
    if (viewing) viewport::wait();
  }

} // view_views


void viewedges()
{
  image im;
  ltatrees ltrees;
  viewport vp;
  for (int ii = first; ii < last; ++ii)
    { 
      if (showedges==2) {
	cout << "------------------" << endl;
      }
      landmarks edgelands, ltalands;
      if (im.read(ii))
	{
	  if (nist)
	    nistprocess(im);	 
	  else 
	    im.blur_downscale(ratio, sd);
	  
	  int x1,y1,x2,y2,x3,y3;
	  if (alpha2>0)
	  im.std_process(0, alpha2, 0, 0, x1, y1, x2, y2, x3, y3);

	}
      else
	{
	  im.init(100,100);
	  im.clear();
	}
	  vp.add_grid(im);

      if (landdir!="")
	{
	  im.normalize(imrange*numcolors,(1-imrange)*numcolors-1);
	  edgelands.read(ii);
	  vp.clear_geom();
	  for (int i = 0; i <  edgelands.total_types() ; ++i) 
	    {
	      if (showedges==2)
		vp.clear_geom();
	      if (edgelands.type_count(i) > 0) 
		{
		  for (int j = 0; j < edgelands.type_count(i); ++j)
		    vp.add_point(edgelands.location_x(i, j), 
				 edgelands.location_y(i, j), basecol, 2*pixsize);
		  if (showedges==2) {
		    cout << "Type " << i << endl;
		    vp.view();    	
		  }	
		}
	   
	    }
	  if (showedges==1)
	    vp.view();
	}
      else
	{
	  if (showedges>0)
	    onlyedges=1;
	  void extract_landmarks(image& im, ltatrees& ltrees, int numltas,
			 landmarks& edgelands, landmarks& ltalands);
	  //onlyedges=1; 
	  extract_landmarks(im, ltrees, numltas, edgelands, ltalands);
	}
      
    }
}
// __________________________________________________________________________


void view_ltas()
{
  int read_ltatrees(ltatrees& ltrees, simpstrg direc);
  ltatrees ltrees;
  image im;


  image tim;
  igrid point1, point2, point3;
  int img=0;
  if (dataset!="")
   {
     if (tim.read(first)) {
       read_coords(point1, point2, point3, ratio, first, first+1);
       tim.blur_downscale(ratio, sd);
       tim.normalize(numcolors-1);
       img=2;
     }
     else
       img=1;
   }
  if (dumpdetections==1)
    img=1;
  int xx1=0,yy1=0,xx2=0,yy2=0,xx3=0,yy3=0;
  if (img==2){
    for (int i=0; i<tim.dimx(); i++)
      for (int j=0; j<tim.dimy(); j++)
	im(ltatree1x-point1(0,0)+i,ltatree1x-point1(0,1)+j)=tim(i,j);
    im.imtrim(10, xx1, yy1, xx2, yy2, xx3, yy3);
  }

  xx1= -xx1;
  yy1= -yy1;

  xx1 += LBX;
  yy1 += LBY;
  //  dum1=2;
  viewport vp;
  if (img==1)
    {
      tim.init(dum1,dum1);
      tim.clear();
      vp.add_grid(tim);
    }
  igrid tmplist(numltas,2);
  int centx=0;
  int centy=0;
  int numl=read_ltatrees(ltrees,ltatreedir);
  if (numl < numltas)
     numltas=numl;
  if (dum2==0)
    dum2=1;
  for (int i = 0; i < numltas; i+=dum2)
  {
    
    int ii=i+firsttree;
    if (ii >= numl)
      break;
    int x = ltrees[ii].locationx - xx1;
    int y = ltrees[ii].locationy - yy1;
    centx+=x;
    centy+=y;
    cout << "point " << ii << " " << x << " " << y << " " << ltrees[ii].tnear << endl;
    if (img)
      vp.add_point(x, y, basecol,1);
    tmplist(i,0)=x; tmplist(i,1)=y;
    if (ltausedepth==0)
      {
	if (img)
	  vp.add_edge(x,y, ltrees[ii].tnear);
      }
     else if (ltausedepth > 0) {


      ltaiter d = ltrees[ii].top();
      int edge1 = d->que.r1.land1;
      int edge2 = d->que.r1.land2;

    if (ltausedepth>=1)
      {
	cout << " feature " << edge1 << " ";
      cout << (int)d->que.r1.ang << " " << edge2 << " ";
      if (img)
	vp.add_edge(x,y, edge1);
      if (simple==1)
	{
      	  int ang=d->que.r1.ang;
	  if (img)
	  vp.add_edge(int(x +  2*relmasksx(ang,1)),
		      int(y + 2*relmasksy(ang,1)), edge2);
	  if (img)
	  vp.add_line(x,y, int(x +  2*relmasksx(ang,1)),
		      int(y + 2*relmasksy(ang,1)),basecol);
	}
      else if (simple==0)
	{      // Draw connecting line
	  double ang1 = d->que.r1.relangle();	
	  if (img)
	  vp.add_edge(int(rint(x +  near * cos(ang1))),
		      int(rint(y -  near * sin(ang1))), edge2);
	  if (img)
	  vp.add_line(x, y, int(rint(x + near * cos(ang1))), 
		      int(rint(y - near * sin(ang1))),basecol);
	}
      }
    if (ltausedepth > 1) {
      while (d.yes() && d.yes().branch() && d.depth()<ltausedepth-1)
	{
	  d = d.yes();
	  edge1 = d->que.r1.land1;
	  if (simple==1)
	    {
	      int ang=d->que.r1.ang;
	      if (img)
	      vp.add_edge(int(x +  2*relmasksx(ang,1)),
			  int(y + 2*relmasksy(ang,1)), edge1);
	      if (img)
	      vp.add_line(x,y, int(x +  2*relmasksx(ang,1)),
			  int(y + 2*relmasksy(ang,1)),basecol);
	    }
	  else if (simple ==0)
	    {      // Draw connecting line
	      double ang1 = d->que.r1.relangle();	
	      if (img)
	      vp.add_edge(int(rint(x +  near * cos(ang1))),
			  int(rint(y -  near * sin(ang1))), edge1);
	      if (img)
	      vp.add_line(x, y, int(rint(x + near * cos(ang1))), 
			  int(rint(y - near * sin(ang1))),basecol);
	    }
	  cout << (int)d->que.r1.ang << " " << edge1 << " ";
      }
      cout << endl;
    }
    cout << endl;
    }
  }

  if (simple >=0 && img)
    {
     
      vp.add_point(ltatree1x - xx1, ltatree1y - yy1, basecol);
      vp.add_point(ltatree2x - xx1, ltatree2y - yy1, basecol);
      vp.add_point(ltatree3x - xx1, ltatree3y - yy1, basecol);
      cout << "centers " << centx/numltas << " " << centy/numltas << endl;
      //      vp.add_point(centx/numltas, centy/numltas,redcol,7);
      if (img==2)  
	vp.add_grid(im);
      vp.view();
	
	for (int i=0; i<numltas; i++)
	  vp.del_point(tmplist(i,0),tmplist(i,1));
	vp.del_point(ltatree1x - xx1, ltatree1y - yy1);
	vp.del_point(ltatree2x - xx1, ltatree2y - yy1);
	vp.del_point(ltatree3x - xx1, ltatree3y - yy1);

    }
} // view_ltas

void view_ltafreqs(igrids &temp, ltatrees &ltrees)
{
  viewport vp;
  vp.add_point(ltatree1x-LBX, ltatree1y-LBY, 10);
  vp.add_point(ltatree2x-LBX, ltatree2y-LBY, 10);
  vp.add_point(ltatree3x-LBX, ltatree3y-LBY, 10);
  
  igrid point1, point2, point3;
  image tim;
  image im(fcartsizex, fcartsizey);
  im.clear();
  
  for (int jj=0 ; jj<numltas; jj++)
    {
      double ccc=0;
      double cccm=0;
      int newlocx = int(rint(alpha1*ltrees[jj].locationx));
      int newlocy = int(rint(alpha1*ltrees[jj].locationy));
      // Get the counts in the neighborhood of the model location.
      for (int g=-1;g <=1; g++)
	for (int h=-1; h<=1; h++)
	  {
	    ccc = temp[jj](g+newlocx,h+newlocy);
            if (ccc> cccm)
	      cccm=ccc;
	  }
      cout << "lta " << jj << " at " << newlocx << " " << newlocy;
      cout << " counts " << cccm << endl;
      // Show the locations with high counts and the model point
      if (showltas>1)
	{
	  
	  dgrid dtemp(temp[0].dimx(),temp[0].dimy());
	  im.clear();
	  vp.add_point(newlocx-LBX, newlocy-LBY, basecol);
	  if (objprop>=0)
	    {
	      gridfun((temp[jj](i,j)>(objprop*numdata))*temp[jj](i,j),dtemp);
	    }
	  else
	    {
	      gridfun((temp[jj](i,j)<(-objprop*numdata)),dtemp);
	    }

	  dtemp.normalize(imrange*numcolors,(1-imrange)*numcolors-1);
	  gridfun(uchar(dtemp(LBX+i,LBY+j)),im);
	  vp.add_grid(im);
	  vp.view();
	  vp.del_point(newlocx-LBX, newlocy-LBY);
	}
    }
}    



void show_landmarks(image &im, landmarks &edgelands, landmarks & ltalands)
{
  if (showedges>=1)
    {
      image viewim = im;
      viewim.normalize(imrange*numcolors, (1-imrange)*numcolors - 1);
      viewport vp(pixsize*viewim.dimy(),pixsize*viewim.dimx());
      if (showedges < 3)
	vp.add_grid(viewim);
      
      for (int i = 0; i < edgelands.total_types(); ++i)
	{
	  if (edgelands.type_count(i) > 0)
	    {
	      // showedges=2 - each edge map shown separately
	      if (showedges>=2)
		vp.clear_geom();
	      int ii;
	      if (basecol==0)
		ii = i;
	      else
		ii=(int)basecol;
	      for (int j = 0; j < edgelands.type_count(i); ++j)
		vp.add_point(edgelands.location_x(i, j), 
			     edgelands.location_y(i, j), ii, 2);
	      if (showedges>=2)
		vp.view();
	    }
	  
	}
      if (showedges==1)
	vp.view();
      return;
    }
  
  if (!onlyedges)
    {
      if (showltas>=1)
	{
	  image viewim=im;
	  viewim.normalize(imrange, (1-imrange)*numcolors - 1);
	  viewport vp(viewim);

	  for (int i = 0; i < ltalands.total_types(); ++i)
	    {
	      if (showltas==2)
		vp.clear_geom();
	      if (ltalands.type_count(i) > 0)
		{
		  if (showltas==2)
		    cout << " Type "  << i << endl;
		  for (int j = 0; j < ltalands.type_count(i); ++j)
		    {
		      if (showltas <= 3)
			vp.add_point(ltalands.location_x(i, j), 
				     ltalands.location_y(i, j),basecol,2*pixsize);
		      else
			{
			  cout << " LTA " << numbg << " " << 
			    ltalands.location_x(i, j) << " ";
			  cout   << ltalands.location_y(i, j) << endl;
			}
		    }
		  if (showltas==2)
		    vp.view();

		}
	    }
	  if (showltas==1)
	    vp.view();
	  return;      
	}
      
    }
}
// __________________________________________________________________________
// viewgrid.C

#endif // VIEWGRID_C
