// Copyright YALI AMIT, January 15, 2001.

#ifndef XOBJECT_H
#define XOBJECT_H

#ifndef NOX

#define String XString
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#undef String

// __________________________________________________________________________


class xobject
{

public:
  static int objcount;
  static int inited;

  // Display data
public:
  static Display *display;
  static int screen;

  // Window and Window Manager data
  static XSetWindowAttributes xswa;
  static Atom wmdw;
  static XClassHint xch;
  static XSizeHints xsh;
  static XWMHints xwmh;

  // Color data
  static Colormap cmap;
  static XColor grays[256];
  static XColor defs[8];

  // Font data
  static XFontStruct *xfs;
  static int fontheight;
  static int fontwidth;

public:
  xobject() { if (objcount++ == 0) if (!initX()) 
             { cerr << "Unable to init X" << endl; exit(1); } } 
  ~xobject() { if (--objcount == 0) quitX(); } 
  static int initX();
  static int quitX();

}; // class xobject

// __________________________________________________________________________
// xobject.h

#endif // NOX

#endif

