// Copyright YALI AMIT, January 15, 2001.


// __________________________________________________________________________
// Include files

#include <cassert>
#include <cmath>
#include <iostream>
#include "simpstrg.h"
#include <cstdlib>
// __________________________________________________________________________
#define STRLEN 255
//char *ltos(const long x);


template <class T>
class treeiteratortri
{
  class treenodetri
  {
   public:
    treenodetri *parent, *son1, *son2, *son3;
  T data;  
    treenodetri(treenodetri* p = 0, treenodetri* s1 = 0, treenodetri* s2 = 0, treenodetri* s3 = 0) : 
        parent(p), son1(s1), son2(s2), son3(s3) { }
  };
  

 private:
  treenodetri *p;

 public:

  treeiteratortri(treenodetri *x = 0) : p(x) { }
  treeiteratortri(const treeiteratortri<T>& t) : p(t.p) { }
  void freenode() const { delete p;  }
  void makenode(treenodetri* pa = 0, treenodetri* s1 = 0, treenodetri* s2 = 0,
		treenodetri* s3=0)
    { p = new treenodetri(pa, s1, s2, s3); }
  void makechildren() const
    { 
      p->son1 = new treenodetri(p, 0, 0, 0);
      p->son2 = new treenodetri(p, 0, 0, 0);
      p->son3 = new treenodetri(p, 0, 0, 0);
    }
  int freechildren() const
    {
      if (p->son1 && (p->son1)->son1==0 )
	{
	  delete p->son1; p->son1=0; 
	  delete p->son2; p->son2=0;
	  delete p->son3; p->son3=0;
          return 1;
	}
       else 
          return 0;
    }
  void operator=(const treeiteratortri<T>& t) { p = t.p; }
  int operator==(const treeiteratortri<T>& t) const { return (p == t.p); }
  operator int() const { return (p ? 1 : 0); }
  T* operator->() const {  return &p->data; }
  treeiteratortri<T> parent() const { return treeiteratortri<T>(p ? p->parent : 0); }
  treeiteratortri<T> son1() const { return treeiteratortri<T>(p ? p->son1 : 0); }
  treeiteratortri<T> son2() const { return treeiteratortri<T>(p ? p->son2 : 0); }
  treeiteratortri<T> son3() const { return treeiteratortri<T>(p ? p->son3 : 0); }
  int branch() const { return (p && p->son1 != 0 && p->son2 != 0 && p->son3 != 0); }
  int leaf() const { return (p && p->son1 == 0 && p->son2 == 0 && p->son3==0); }
   int ord() const { if (p && p->parent) 
		       {
                       if( p->parent->son1==p)
                                return(1);
		       else if (p->parent->son2==p)
                                return(2);
		       else 
                                return(3);
		       }
                     else
		       return(0);
      
  }

  void itertri();
  int depth() const { return (p && p->parent ? 1 + parent().depth() : 0); }
  simpstrg history() const {
    return (p && p->parent ? (parent().history() + ltos(ord())) : simpstrg("")); 
  }
  
 
}; // class treeiteratortri<T>

// __________________________________________________________________________



template <class T>
class treetri
{
private:
  treeiteratortri<T> tt;
  void freenodes(const treeiteratortri<T>& t);

public:
  treetri() { }
  ~treetri() { freenodes(tt); }
  void maketop() { tt.makenode(); }
  const treeiteratortri<T> top() const { return tt; }
};

template <class T>
inline void treetri<T>::freenodes(const treeiteratortri<T>& t)
{
  if (!t)
    return;

  if (t.branch()) {
    freenodes(t.son1());
    freenodes(t.son2());
    freenodes(t.son3());
  }

  t.freenode();

} // tree::freenodes

class roadtree;
class roadata;
typedef treeiteratortri<roadata> roaditer;


class roadata
{ 
 private:

 public:
  double  p1[2],p2[2];
  int angindex;
  double zold;
  double znew;
  int Y;
 void getpoints(const roaditer& par, int type); 
 roadata() {zold=1; Y=-1; }

 void dump() {  cout << " Points1 " << p1[0] << " " << p1[1] << endl;
                cout << " Points2 " << p2[0] << " " << p2[1] << endl;
                cout << " Angindex " << angindex << endl;
                cout << " z " << zold << endl;
                cout << " Y " << Y << endl;}
};


class roadtree;
class roadata;
typedef treeiteratortri<roadata> roaditer;



class roadtree : public treetri<roadata>
{
 private:

 public:
  void itertri(const roaditer& tt);
  
};
// __________________________________________________________________________
// curve_tree.h


