// Copyright YALI AMIT, January 15, 2001.

#include <iostream>
#include <cstdio>

#include "includes.h"
#include "image.h"
#include "trainstat.h"
#include "detection.h"
#include "ltatree.h"
#include "viewgrid.h"
#include "viewport.h"
#include "globals.h"
#include "wave.h"
#include "timer.h"
#define log2(a) log((double)a)/log(2.)

double cost();
double lamfun(int i, int j);
void init_twod();
void calchess();
void step_FREQ(dgrid &appl);
void incdim();
void makewavelets();
void xrestore1(int niters);
void getdef();
void blur_subsample(dgrid &th, double ratio, double sd);
void twod_el(dgrid &im1, dgrid &im2);
void plotuv1(viewport &vp, dgrid &fx, dgrid &fy, int jump, int defpixsize);
void match_points(dgrid &u, dgrid &v, int bs1,int bs2, igrid &in, igrid &out);

dgrid sumlam;
dgrid diff; 
dgrid appl, def_gradx, def_grady;
// Working resolution arrays.
dgrid sdata, sitemplate, sitemplate_big, sitemplate_big_gradx, sitemplate_big_grady;
// Working resolution field
dgrid sfield_x, sfield_y;
// Original resolution arrays.
dgrid itemplate_big, idata, itemplate;
// Original resolution field
dgrid field_x, field_y;

// Wavelet coeficient arrays
dgrid freq_x, freq_y;

// Lamda multipliers.
dgrid lamda_x, lamda_y;

int size_dat, hdim, dim_curr, ND, fd;

double xxxo=1000000;

// Parameters defining subdomain of image within larger template image
// At working resolution
int lbx,lby,ubx,uby;

// Parameters defining subdomain of image within larger template image
// At working resolution (LBX, LBY are global) and UBX, UBY are computed
// below
int UBX, UBY;

// Largest number of coeficients to update.
int L;

int bcount;

double dtscf=1.;
int DISPLAYN=1;
double HESS;
double dt, resod;

// A vector of dgrids for explicit wavelet functions.
vector<dgrids> wavelets;

// For display purposes.
image TEMP_DEF,STEMP_DEF,DIFF,SDIFF;

// Read in 2 images from `dataset' 
// the first serves as the prototype and the second
// as the data image
void twod_el()
{
  void twod_el(image &im1, image &im2);
  image im1,im2;
  
  
  swap(dataset,tempdataset);
  cout << dataset << endl;
  im1.read(tempnum);
  swap(dataset,tempdataset);
  cout << dataset << endl;
  im1.normalize(0,255.);
  im1.blur_downscale(ratio, sd);
  im1.normalize(0,255.);

  im2.read(first);
  im2.normalize(0,255.);
  im2.blur_downscale(ratio, sd);
  im2.normalize(0,255.);
  
  dgrid itemp, idat;
  
  // Transfer images to a double precision array
  itemp.init(im1.dimx(),im1.dimy());
  gridfun(im1(i,j),itemp);
  idat.init(im2.dimx(),im2.dimy());
  gridfun(im2(i,j),idat);
  twod_el(itemp, idat);
  
}


// Run the deofrmable image algorithm on two double precision arrays.
void twod_el(dgrid &itemp, dgrid &idat)
{

  // How many basis coeficients to start out with
  if (FIRSTDIM==0)
    FIRSTDIM=1;
  if (post==0)
    post=1; // Weight on data term
  itemplate_big = itemp;                     
  idata = idat;

  // Normalize values between 0 and 1.
  itemplate_big.normalize(0.,1.);
  idata.normalize(0.,1.);
  
  // Prepare parameters of selected Daubechies wavelet basis
  makevec(base);

  // Initialize all the relevant arrays
  init_twod();
  // Start running the iterations.
  timer timer1;
  timer1.start("Starting iterations");
  xrestore1(numiters);
  timer1.stop("Ended iterations");
}

// Synthesize random deformations of an image.
void synth()
{
  void synth(image &im, int p10 = -1, int p11 = -1, int p20 = -1, int p21 = -1,
	     int p30 = -1, int p31 = -1);
  
  void  embedd_in_pow2(image& im);
  void makevec(int N);
  // Prepare parameters of selected Daubechies wavelet basis
  makevec(base);
  
  image im, ims;
  // Read in prototype image.
  im.read(first);
  im.blur_downscale(ratio, sd);
  int orig_x=im.dimx();
  int orig_y=im.dimy();

  embedd_in_pow2(im);
  int marg_x=(im.dimx()-orig_x)/2;
  int marg_y=(im.dimy()-orig_y)/2;

  int numperrow = last;
  int boxsize = im.dimx()+2*(int)scale;
  int isize = numperrow * (boxsize);
  int jsize = (numiters / numperrow ) * (boxsize) + scale;
  images outim(numiters);
  image bigimage(isize, jsize);
  bigimage.clear();
  for (int a=0; a < numiters; a++) {
    ims = im;
    // Apply random wavelet expansion displacement field to image
    synth(ims);
    outim(a).init(orig_x,orig_y);
    gridfun(ims(marg_x+i, marg_y+j),outim(a));
    int starty = (a / numperrow) * (boxsize)+scale;
    int startx = (a % numperrow) * (boxsize)+scale;
    for (int i = 0; i < boxsize; ++i)
      for (int j = 0; j < boxsize; ++j)
	bigimage(startx + i, starty + j) = ims.get(i, j);
  }
  cout << " numdigits " << numdigits << endl;
  bigimage.normalize(numcolors-1);
  viewport vp(bigimage);
  vp.view();
  void writce_images(const vector<image>& im, int ndigits);
  images wim(1);
  wim(0)=bigimage;
  cout << " numdigits " << numdigits << endl;
  if (numdigits==0)
    write_images(wim,1);
  else
    write_images(outim,numiters);
}    

// Apply random wavelet expansion displacement field to image
void synth(image &im, int p10 = -1, int p11 = -1, int p20 = -1, int p21 = -1,
int p30 = -1, int p31 = -1)
{
void matiid(dgrid &e);
  int nx=im.dimx();
  int ny=im.dimy();


  dgrid dim(nx,ny);
  gridfun(double(im(i,j)),dim);
  dgrid dimdef(nx,ny);
  dgrid field_x(nx,ny);
  field_x.clear();
  dgrid field_y(nx,ny);
  field_y.clear();
  dgrid lamda(nx,ny);
  dgrid gaux(nx+4,ny+4);
  dgrid gauy(nx+4,ny+4);

  L = nx;
  // Create the lamda multipliers (inverse variances)  of the wavelet
  // coeficients.
  gridfun(lamfun(i,j),lamda);

  // Get 2 iid Gaussian matrices.
  matiid(gaux);
  matiid(gauy);
  // LASTDIMxLASTDIM - number of coeficients to sample. (log_2(LASTDIM))
  // is the highest resolution being used.
  for (int x=nx-LASTDIM; x<nx; x++)
    for (int y=ny-LASTDIM; y<ny; y++)
      {
	// Multiply Gaussian by appropriate multiplier and set as
	// random wavelet coeficient.
	field_x(x,y) = (prior_fac/lamda(x,y))*gaux(x+2,y+2);
	field_y(x,y) = (prior_fac/lamda(x,y))*gauy(x+2,y+2);
      }

  // Inverse wavelet transform to create displacement fields.
  unwavep2(field_x,1);
  unwavep2(field_y,1);

  // Find mapping of the anchor points
  if (p10 >= 0)
    {
      igrid in(3,2);
      igrid out(3,2);    
      in(0,0) = p10;
      in(0,1) = p11;
      in(1,0) = p20;
      in(1,1) = p21;
      in(2,0) = p30;
      in(2,1) = p31;
      match_points(field_x, field_y, LBX, LBY, in, out);  
      
      p10 = out(0,0);
      p11 = out(0,1);
      p20 = out(1,0);
      p21 = out(1,1);
      p30 = out(2,0);
      p31 = out(2,1);
    }


  // Apply displacement fields to image.
  applyuv_smt1(field_x, field_y, dim, dimdef, 0, 0);
  if (dumpdetections==1)
    {
      int defpixsize=2;
      viewport vp_field(defpixsize*field_x.dimx()*10/8,defpixsize*field_x.dimy()*10/8);
      plotuv1(vp_field, field_x, field_y, arrow_spacing, defpixsize);
      vp_field.view();
    }
  // Overwrite original image with deformed image.
  gridfun((unsigned char)dimdef(i,j),im);

}



// Make arrays with actual wavelet functions.
// Inverse wavelet transform of standard basis
// matrix (1 at one place and zero everywhere else).
void makewavelets()
{
  // Create wavelet functions
int dimx=appl.dimx();
int dimy=appl.dimy();
dgrid temp(dimx,dimy);
  wavelets.init(LASTDIM);
  // Loop through all standard basis vectors and apply inverse transform
  for (int i = 0; i < LASTDIM; i++)
    {
      wavelets[i].init(LASTDIM);
      for (int j = 0; j < LASTDIM; j++)
	{
	  temp.clear(0);
	  temp(dimx-LASTDIM+i,dimy-LASTDIM+j)=1;

	  unwavep2(temp,1);
	  wavelets[i][j]=temp;
	  //temp.dump();
	}
    }

}

// The linear least square deformation algorithm.
void linear(dgrid &appl, dgrid &data, dgrid &freq_x, dgrid &freq_y)
{

int dimx = appl.dimx();
int dimy = appl.dimy();
dgrid appl_x(appl.dimx(),appl.dimy());
dgrid appl_y(appl.dimx(),appl.dimy());
  GRADIENT(appl,appl_x,appl_y);

  int curr2 = dim_curr*dim_curr;

  cout << curr2 << endl;
  // Augemented A matrix
  dgrid A(dimx*dimy + 2*curr2,2*curr2);
  A.clear();
  // Augemented b matrix
  dgrid b(dimx*dimy + 2*curr2);
  b.clear();
  dgrid xx(2*curr2);
  for (int k=0; k<dimx*dimy; k++)
    {
      int x = k / dimx;
      int y = k % dimy;
      b(k) = data(x,y)-appl(x,y);
      for (int d=0; d<curr2; d++)
	{
	  int i = d/dim_curr;
	  int j = d % dim_curr;
	  A(k,d) = wavelets[LASTDIM-dim_curr+i][LASTDIM-dim_curr+j](x,y)*appl_x(x,y);
	  A(k,d + curr2) = wavelets[LASTDIM-dim_curr+i][LASTDIM-dim_curr+j](x,y)*appl_y(x,y);
	  
	}
    }
  
  for (int d=0; d < curr2; d++)
    {
      int i = d/dim_curr;
      int j = d % dim_curr;
      A(d+dimx*dimy,d) = prior_fac*lamda_x(LASTDIM-dim_curr+i, LASTDIM-dim_curr+j);
      A(curr2+d+dimx*dimy,curr2+d) = prior_fac*lamda_x(LASTDIM-dim_curr+i, LASTDIM-dim_curr+j);
    } 
  
  // USe QR to solve the augmented LS problem
  void solve_lsq(dgrid& A, const dgrid& b, dgrid& x);
  solve_lsq(A, b, xx);
  //  xx.dump();
  
  for (int d=0; d<curr2; d++)
    {
      int i = d/dim_curr;
      int j = d % dim_curr;
      
      freq_x(LASTDIM-dim_curr+i,LASTDIM-dim_curr+j)+=xx(d);
      freq_y(LASTDIM-dim_curr+i,LASTDIM-dim_curr+j)+=xx(curr2+d);
    }
  
}

// Evaluate cost function at a given deformed image.
// diff contains difference between deformed prototype
// and target image.
double cost()
{
  
  // Data cost
  double xxx=0;
  
  for (int i=0; i<diff.dimx(); i++)
    for (int j=0; j<diff.dimy(); j++)
      xxx += diff(i,j)*diff(i,j);
  xxx = xxx*post;
  // Prior cost
  if (dum1){
    for (int ii=fd; ii<L; ii++)
      for (int jj=fd; jj<L; jj++)
	{
	  xxx += prior_fac*lamda_x(ii,jj)*freq_x(ii,jj)*freq_x(ii,jj);
	  xxx += prior_fac*lamda_y(ii,jj)*freq_y(ii,jj)*freq_y(ii,jj);
	}
  }
  return(xxx);
}


// Main Loop
void xrestore1(int niters)
{

  viewport vpdef_temp, vpdiff;
  viewport vpdef_stemp, vpsdiff;
  int defpixsize=4;
  int oldpixsize=1;
  if (defpixsize*sfield_x.dimx()>128)
    defpixsize=2;
  
  viewport vp_field(defpixsize*sfield_x.dimx()*10/8,defpixsize*sfield_x.dimy()*10/8); 
  viewport vpd_field(field_x.dimx()*10/8,field_x.dimy()*10/8); 
  int jump=arrow_spacing;
  
  // Every how often to display result.
  DISPLAYN=displayinter;
  // Current number of coeficients updated.
  dim_curr = FIRSTDIM;
  ND = sdata.dimx()-dim_curr;
  fd = L-dim_curr;
  // Estimate of time step.
  dt = dt_scale_factor/(dim_curr*dim_curr*post*HESS+sumlam(dim_curr));
  cout << " Dim - " << dim_curr << " time-step - "<< dt << endl;printf("Dim - %d, step - %g \n",dim_curr,dt);
  bcount=0; 

  // If linearized method used make the explicit wavelet basis arrays.
  if (linear_elas)  
    makewavelets();

  // For display purposes.
  image DATA(idata.dimx(), idata.dimy());
  gridfun((uchar)(idata(i,j)*(numcolors-1)),DATA);
  DATA.normalize(imrange*numcolors,(1-imrange)*numcolors-1);
  viewport vpdata;
  vpdata.add_grid(DATA);
  image TEMP(itemplate_big.dimx(), itemplate_big.dimy());
  gridfun((uchar)(itemplate_big(i,j)*(numcolors-1)),TEMP);
  TEMP.normalize(imrange*numcolors,(1-imrange)*numcolors-1);
  viewport vptemp;
  vptemp.add_grid(TEMP);

  // SHow prototype and data images.
  vpdata.refresh();
  vptemp.view();
  
  // Iterate
  for(int II=1; II<=niters; II++)
    {
      double xxx;
      if (dumpdetections>=1)
      cout << " II " << II << " dimcurr " << dim_curr << endl;

      // Get the deformed protoype
      applyuv_smt1(sfield_x, sfield_y, sitemplate_big, appl, lbx, lby);


      // Check cost function
      // and get the difference image at the same time into global variable 
      // `diff'
      gridfun(sdata(i,j)-appl(i,j),diff);
      xxx = cost();
      
      if (dumpdetections>=1)
	{
	  printf("energy - %3.3f \n",xxx);
	  cout << fabs(xxx-xxxo)/xxxo << endl;
	}
	// Check relative change in cost function. If too small increase
	// number of coeficients being updated.
        if (II>1 && fabs(xxx-xxxo)/xxxo < minenergychange) 
	  {
	    if (dim_curr < L) incdim();
	    bcount=0;
	  }
	xxxo = xxx;
	 
	// If linear method
	if (linear_elas)
	  {
	    cout << " DOING LINEAR " << endl;
	    linear(appl,sdata,freq_x,freq_y);
	  }
	else
	  // Implement one step of the gradient flow on the coeficients
	  step_FREQ(diff);
	
	// Generate the field at the required points
	sfield_x.clear();
	// Copy coeficient data to field arrays then do inverse transform.
	sfield_x.subcopy(fd,L,fd,L,freq_x,ND,ND); 
	unwavep2(sfield_x,1);
	sfield_y.clear();
	sfield_y.subcopy(fd,L,fd,L,freq_y,ND,ND); 
	unwavep2(sfield_y,1);
	
	// If time to display.
	if ( ((II%DISPLAYN)==0 && dumpdetections>=1) || (II==numiters-1 && dumpdetections>=1)) {
	  // If deformation is being estimated at a lower resolution
	  // show outcome on original resolution/
	  if(resod>1)
	    {
	      // Get deformation at scale of original images
	      // This is an interpolation using the same wavelet basis.
	      getdef(); 
	      dgrid itemplate_def(idata.dimx(),idata.dimy());
	      image TEMPR(idata.dimx(),idata.dimy());
	      // Apply higher resolution field to original resolution prototype
	      applyuv_smt1(field_x, field_y, itemplate_big, itemplate_def,LBX,LBY);
	      
	      // Display stuff.
	      gridfun(uchar(itemplate_def(i,j)*(numcolors-1)),TEMPR);
	      vpdef_temp.add_grid(TEMPR);
	      vpdef_temp.refresh();
	      // Show residual
	      gridfun(1. - fabs(itemplate_def(i,j)-idata(i,j)), itemplate_def);
	      gridfun(uchar(itemplate_def(i,j)*(numcolors-1)),TEMPR);
	      vpdiff.add_grid(TEMPR);
	      vpdiff.refresh();
	      // 	plotuv1(vpd_field, field_x, field_y, jump, 1);
	    }
	  else
	    {
	      field_x=sfield_x;
	      field_y=sfield_y;
	    }
	  

	ucgrid STEMP(sdata.dimx(),sdata.dimy());
	// Apply new field to prototype at working resolution
	applyuv_smt1(sfield_x, sfield_y, sitemplate_big, appl,lbx,lby);
	
	// Display stuff
	gridfun(uchar(appl(i,j)*(numcolors-1)),STEMP);
	STEMP.normalize(imrange*numcolors,(1-imrange)*numcolors);

        vpdef_stemp.add_grid(STEMP);
	vpdef_stemp.refresh();
	
	gridfun(1. - fabs(appl(i,j)-sdata(i,j)), appl);
	gridfun(uchar(appl(i,j)*(numcolors-1)),STEMP);
	STEMP.normalize(imrange*numcolors,(1-imrange)*numcolors);
	vpsdiff.add_grid(STEMP);
	vpsdiff.refresh();

       
	swap(pixsize,oldpixsize);            
	// Plot displacement field.
	plotuv1(vp_field, sfield_x, sfield_y, jump, defpixsize);
	if (dumpdetections==2)
	  vp_field.view();
	swap(pixsize,oldpixsize);            

	}
    } // End of Iteration loop.

  if (dumpdetections>=1)
      vptemp.view();


  igrid in;
  // Get points on prototype image to be found through
  // deformation on data.
  if (dumpdetections>=1)
    {
      vptemp.get_marked_points(in);
      
      if (in.dimx()==0)
	return;
      in.dump();
      
      igrid out(in.dimx(),in.dimy());
      // Find map of selected points (inverse of current deformation)
      match_points(field_x, field_y, LBX, LBY, in, out);
      
      out.dump();
      for (int p=0; p<out.dimx(); p++)
	vpdata.add_point(out(p,0),out(p,1),basecol,4);
      
      vpdata.view();
    }

}

 


void init_twod()
{

  void imbedd_in_pow2(dgrid &in);
  image im;
  viewport vp;
  
  // Embedd the data image in a power two image.
  imbedd_in_pow2(idata);
  
  cout << newres << " " << idata.dimx() << " " << itemplate_big.dimx() << endl;
  // Newres is working resolution at which to implement algorithm
  if (newres==0 || newres > idata.dimx())
    newres=idata.dimx();
  // LxL highest number of coeficients to update.
  if (LASTDIM==0)
    L = newres;
  else
    L = LASTDIM;
  // Initialize wavelet vector
  size_dat = idata.dimx();
  hdim=int(size_dat);
  cout << hdim << " hdim " << endl;

  // Down scaling amount.
  resod = size_dat/newres;
  cout << "resod " << resod << endl;
  sdata=idata;
  // Down sample image to working resolution
  blur_subsample(sdata,1./resod, sd);

  // EMbedd prototype in power of 2 as well.
  imbedd_in_pow2(itemplate_big);
  cout << "BIG " << itemplate_big.dimx();
  if (reverseimage)
   {
     gridfun(1.-itemplate_big(i,j),itemplate_big);
   }
  itemplate.init(idata.dimx(),idata.dimy());
 
  // The template may be bigger than the data which
  // is convenient for getting values for displacements
  // which reach outside the domain. The actual domain at
  // full resolution is then given by LBX,UBX, LBY, UBY
  // and at working resolutino by lbx,ubx, lby,uby.
  // In computation only sitemplate_big is used.
  // For display only sitemplate is used.
  gridfun(itemplate_big(LBX+i,LBY+j),itemplate);

 
  UBX = LBX + idata.dimx();
  UBY = LBY + idata.dimy();
  lbx = int(LBX/resod);
  lby = int(LBY/resod);
  ubx = int(UBX/resod);
  uby = int(UBY/resod);
  sitemplate_big=itemplate_big;
  //  Blur and subsample bi template.
  blur_subsample(sitemplate_big,1./resod, sd);
  sitemplate=itemplate;

  // Blur and subsample subtempalte
  blur_subsample(sitemplate,1./resod, sd);
  size_dat=sitemplate.dimx();

  // Initialize buffers of template gradient.
  sitemplate_big_gradx.init(sitemplate_big.dimx(),sitemplate_big.dimy());
  sitemplate_big_grady.init(sitemplate_big.dimx(),sitemplate_big.dimy());
  // Compute gradient and approximate Hessian.
  GRADIENT(sitemplate_big, sitemplate_big_gradx, sitemplate_big_grady);
  calchess();  

  // Lamda multipliers for prior.
  lamda_x.init(L+1,L+1);
  lamda_y.init(L+1,L+1);
  gridfun( lamfun(i,j),lamda_x);
  gridfun( lamfun(i,j),lamda_y);

  // Temporary buffers.
  appl.init(sitemplate.dimx(),sitemplate.dimy());
  diff.init(appl.dimx(),appl.dimy());
  // Grids for storing deformations at working resolution and
  // original resolution.
  sfield_x.init(sitemplate.dimx(),sitemplate.dimy());
  sfield_x.clear();
  sfield_y.init(sitemplate.dimx(),sitemplate.dimy());
  sfield_y.clear();
  field_x.init(itemplate.dimx(),itemplate.dimy());
  field_y.init(itemplate.dimx(),itemplate.dimy());

  // Arrays for deformed gradients.
  def_gradx.init(sitemplate.dimx(),sitemplate.dimy());
  def_grady.init(sitemplate.dimx(),sitemplate.dimy());

  // Arrays for wavelet coeficients. Maximum dimension is L
  freq_x.init(L,L);
  freq_x.clear();
 
  freq_y.init(L,L);
  freq_y.clear(); 
  sumlam.init(L+1);
  sumlam(0) = 1;

  // Sum of landa multipliers for computation of time step.
  for (int i=1; i<L+1; i++) 
    sumlam(i) = prior_fac*lamda_y(i,i)+sumlam(i-1);
  
}


// Subroutine for adhoc calculation of Hessian to determine timestep 
void calchess()
{
double g = 0;
for (int i=lbx; i<ubx; i++)
  for (int j=lby; j < uby; j++)
    {
      g += sitemplate_big_gradx(i,j)*sitemplate_big_gradx(i,j);
      g += sitemplate_big_grady(i,j)*sitemplate_big_grady(i,j);
    }
HESS = g/(sdata.dimx()*sdata.dimy());
printf(" Hess - %g\n",HESS);
}

// Compute lamda multipliers as function of resolution.
double lamfun(int i,int j)
{

double  x;

if (i+j != L+L-2)
{
  int k = MAX(L-i-1,L-j-1);
  k = int(log2((double)k));
  x = pow(2.,k+1.);
}
else
  {
    x=1.;
  }
return(x);
}

// ITERATION STEP 
void step_FREQ(dgrid &appl)
{
  // Calculate Horizontal and Vertical fields applied to  tempalte gradient
  applyuv_smt1(sfield_x, sfield_y,sitemplate_big_gradx, def_gradx, lbx, lby);
  applyuv_smt1(sfield_x, sfield_y,sitemplate_big_grady, def_grady, lbx, lby);
  
  // multiply by difference in appl 
  gridfun(appl(i,j)*def_gradx(i,j),def_gradx);
  gridfun(appl(i,j)*def_grady(i,j),def_grady);
  
  // Forward transform
  wavep2(def_gradx,1);
  wavep2(def_grady,1);
  
  double xxx=0;
  // Update coeficients according to one step of time discretized
  // gradient flow.
  for (int ii=fd; ii<L; ii++)
    for (int jj=fd; jj<L; jj++)
      {
	int iii = ii-fd+ND;
	int jjj = jj-fd+ND;
       	xxx = -prior_fac*lamda_x(ii,jj)*freq_x(ii,jj)+def_gradx(iii,jjj)*post;
	freq_x(ii,jj)+= xxx*dt;
	xxx = -prior_fac*lamda_y(ii,jj)*freq_y(ii,jj)+def_grady(iii,jjj)*post;
	freq_y(ii,jj)+= xxx*dt;

      }
}

// Increase number of update coeficients and update time step.
void incdim()
{

  dim_curr = dim_curr*2;
  //  ND = sitemplate.dimx()-dim_curr;
  ND = size_dat-dim_curr;
  fd = L-dim_curr;
  dt = dt_scale_factor/(dim_curr*dim_curr*post*HESS+sumlam(dim_curr));
  bcount=0;
cout << " Dim - " << dim_curr << " time-step - "<< dt << endl;
// cout << " fd " << fd << " N
}


// Interpolate a displacement field from working resolution to full resolution
//displacement field 
void getdef()
{
  int nd = hdim-dim_curr;
  
  dgrid temp(hdim,hdim);
  dgrid tempx(hdim,hdim);
  temp.clear();

  // X component of field
  // Inject coeficients in higher resolution matrix
  temp.subcopy(fd,L,fd,L,freq_x,nd,nd); 

  // Inverse wavelet transform in original resolution
  unwavep2(temp,1);
 
  // Ratio between original and working resolution
  double hreso=(hdim/sdata.dimx());

  // If log2 is even multiply by ratio
  if ((int)(rint(log2(hreso)))%2==0)
    {
      gridfun(temp(i,j)*hreso,temp);
    }
  // if log2 is odd transpose and mutiply
  else
    {
      gridfun((temp(j,i)*hreso),tempx);
      gridfun(tempx(i,j),temp);
    }
  
        
  //blur_subsample(temp,1./hr, sd);
  // Inject
  gridfun(temp(i,j),field_x);

  // Y component of field
  temp.clear(); tempx.clear();
  temp.subcopy(fd,L,fd,L,freq_y,nd,nd); 
  unwavep2(temp,1);
  if ((int)(log2(hreso))%2==0)
    {
      gridfun(temp(i,j)*hreso,temp);
    }
  else
    {
      gridfun(temp(j,i)*hreso,tempx);
      gridfun(tempx(i,j),temp);
    }
	  
  //  blur_subsample(temp,1./hr, sd);
  gridfun(temp(i,j),field_y);
  


}
      

// SHow displacement field.
void plotuv1(viewport &vp, dgrid &fx, dgrid &fy, int jump, int defpixsize)
{

  
  int pad = defpixsize*fx.dimx()*1/8;
  vp.clear_geom();
  for (int i=0; i< fx.dimx(); i+= jump)
    {
      int x =  pad+i*defpixsize;
      for (int j=0; j<fx.dimy(); j+= jump)
	{
          int y =  pad +j*defpixsize;
          int x1 = (int)( x + defpixsize*fx.dimx()*fx(i,j) );
          int y1 = (int)( y + defpixsize*fx.dimy()*fy(i,j) );

          vp.add_line(x, y, x1 ,y1,basecol);
          //vp.add_point(x1,y1);
          vp.add_line(x, y, x1-1 ,y1,basecol);
          vp.add_line(x, y, x1+1 ,y1,basecol);
          vp.add_line(x, y, x1 ,y1+1,basecol);
          vp.add_line(x, y, x1 ,y1-1,basecol);
	}
    }

vp.refresh();


}

// The two following subroutines are hacks which should
// have been written for the grid template...

// Embedd image in a power of 2 dimension
void  embedd_in_pow2(image& im)
{
  int mx=MAX(im.dimx(),im.dimy());
  cout << " mx " << mx << endl;
  double lg = log2(mx);
  double lgl = double(rint(lg));
  
  cout << " Lgl " << lg << " " << lgl << endl;
  int hdim=0;
  if (lg - lgl > 0)
    hdim = int(pow(2, lgl+1));
  else
    //    hdim = int(mx); 
    hdim = int(pow(2, lgl));
  cout << "POW2 dim " << hdim << endl;
  int mvx = (hdim-im.dimx())/2;
  int mvy = (hdim-im.dimy())/2;
  
  image nim(hdim,hdim);
  nim.clear();
  for (int i=0; i<im.dimx();i++)
    for (int j=0; j< im.dimy(); j++)
      nim(mvx+i,mvy+j)=im(i,j);
  im=nim;
}




// Embed an dgrid in a larger one with power of 2 dimensions.
void imbedd_in_pow2(dgrid &in)
{
  double nldim, ndim;
  int dim=MAX(in.dimx(),in.dimy());
  double ldim=log2(dim);
  double a=fabs(rint(pow(2,int(rint(ldim))))-dim);
  cout << "In imbedd " << ldim << " " << dim << " " << a << endl;
  if ( a < .001)
    {
      cout << " returning "<< endl;
      return;
    }
  else
    {
      nldim= int(ldim)+1;
      ndim=pow(2,nldim);
    }
  
  cout << "New dimension " << ndim << endl;
  dgrid tt(ndim,ndim);
  tt.clear();
  tt.subcopy(0,in.dimx(),0,in.dimy(),in,(ndim-in.dimx())/2,(ndim-in.dimy())/2);
  in=tt;
  
}


