// Copyright YALI AMIT, January 15, 2001.

#include <iostream>
#include <cstdio>

#include "includes.h"
#include "pixel.h"
#include "image.h"
#include "trainstat.h"
#include "detection.h"
#include "ltatree.h"
#include "viewgrid.h"
#include "viewport.h"
#include "globals.h"
#include "wave.h"


#define log2(a) log((double)a)/log(2.)
void defcont_init(image& im, detection &det);
void init_dynamic(image &im, detection &det);
void twod_el(dgrid &itemp, dgrid &idat);
void register_image(const image& im, partialtrans& pt, 
		     dgrid& regim, ucgrids& reglands, int *tripts, int j,
		    int cstyle, int csizex, int csizey, ucgrid& pmask,
                    int lsq, int unions = 0);

int process_template(image &imorig, detection &det, partialtrans fpt, ucgrid &fpmask)
{

image temp;
dgrid regim2;
ucgrids reglands2;
if (templatestyle >= 3 && templatestyle <= 6)
  {
    partialtrans fpt(Pixel(defpoint1x, defpoint1y), 
		     Pixel(defpoint2x, defpoint2y),
		     Pixel(defpoint3x, defpoint3y));
    register_image(imorig,  fpt, regim2, reglands2, 
		   det.tripts, 0, 0, defsizex, defsizey, fpmask,
		   fleastsquares);
    regim2.normalize(0.,255.);
    temp.init(regim2.dimx(),regim2.dimy());
    gridfun((uchar)(regim2(i,j)),temp);
    image ttemp=temp;
    view_normalized(ttemp);

   }

 
  if (templatestyle==1) 
    {
      imorig.normalize(numcolors-1);
      defcont_init(imorig, det);
    }
  if (templatestyle==2)
    {
      imorig.normalize(numcolors-1);
      init_dynamic(imorig, det);
    } 
  if (templatestyle==3) 
   {
     dgrid meanim;
     image tim;
     
     
     Ifstream (rofs,"MEAN");
     if (rofs)
       meanim.read(rofs);
     else
       {
         simpstrg olddataset=dataset;
	 dataset=tempdataset;
	 tim.read(tempnum);
         dataset=olddataset;

      
	 meanim.init(tim.dimx(),tim.dimy());
     
	 gridfun(tim(i,j),meanim);
       }
     meanim.normalize(0.,255.);
    
     post=1; 
     pixsize=2;
     // Maybe stuff for faces???
     //temp.histeq();
     //gridfun(temp(i,j),regim2);
     //gridfun((uchar)(meanim(i,j)*fpmask(i,j)),temp);
     //gridfun((uchar)(meanim(i,j)),temp);
     //       temp.histeq();
     //gridfun(temp(i,j),meanim);
     
     twod_el(meanim, regim2);
     pixsize=1;
   }
 if (templatestyle==4)
   {
     void twod_els(image &regim2);
     twod_els(temp);
     
   }
 if (templatestyle==5)
   {
     detection newdet;
     pixsize=2;
     newdet.tripts[0]=defpoint1x; newdet.tripts[1]=defpoint1y;
     newdet.tripts[2]=defpoint2x; newdet.tripts[3]=defpoint2y;
     newdet.tripts[4]=defpoint3x; newdet.tripts[5]=defpoint3y;
     defcont_init(temp, newdet);
     pixsize=1;    
   }

 if (templatestyle==6)
   {
     pixsize=2;
     detection newdet;
     newdet.tripts[0]=defpoint1x; newdet.tripts[1]=defpoint1y;
     newdet.tripts[2]=defpoint2x; newdet.tripts[3]=defpoint2y;
     newdet.tripts[4]=defpoint3x; newdet.tripts[5]=defpoint3y;
     init_dynamic(temp, newdet);
   }
return 1;
}


