// Copyright YALI AMIT, January 15, 2001.

#include "includes.h"

#include <iostream>
#include <iomanip>
#include <fstream>
#ifndef NOX
//#include <unistd.h>
#endif
#include <ctime>

#include "simpstrg.h"
#include "histgram.h"
#include "facecart.h"
#include "detection.h"
#include "trainstat.h"
#include "ltatree.h"
#include "carttree.h"
#include "viewgrid.h"
#include "viewport.h"
#include "globals.h"
#include "detfuncs.h"
#define log2(a) log((double)a)/log(2.)


extern images IMV;
extern int CURRDET, CURRIM;
void nistprocess(image &im);

void detect()
{
  if (viewdetections==2)
    {
      IMV.init(numdata);
      CURRDET=0;
    }
  ifstream ifs;
  if (listfile != "")
    ifs.open(listfile);
  char buf[255];
  if (listfile != "")
    {
      for (int i=0; i<first; ++i )
	ifs.Getline(buf, 255);
    }
  for (int i = first; i < last; ++i) 
    {
      CURRIM=i;
      image im, im2;
      detections dets;
      if (listfile == "")
	im.read(i);
      else
	{
	  if(ifs.Getline(buf, 255))
	    im.read(buf);
	  cout << buf << endl;
	}
      
      im.blur_downscale(ratio, sd);
      viewport vp;
      if (showtriangles)
	{
	  im2 = im;
	  if (basecol==0)
	    im2.normalize(0, numcolors - 1);
	  else 
	    im2.normalize(imrange*numcolors,(1-imrange)*numcolors-1);
	  vp.add_grid(im2);
	  if (!makecoords)
	    vp.refresh();
	}
      
      
      finddets(im, "", dets, "");
      output_detections(vp, im, dets);
      
    }
  if (viewdetections==2)
    {
      write_images(IMV,CURRDET);
      cout << "CURRDET " << CURRDET << endl;
    }
}



void test_images()
{
  int good=0;
  int totdet=0;
  igrid point1, point2, point3;

  igrid clcount(10);
  clcount.clear();
  igrid cldet(10);
  cldet.clear();
  igrid clclass(10);
  clclass.clear();
  read_coords(point1,point2,point3, ratio, first, last);

  if (viewdetections==2)
    {
    IMV.init(numdata);
    CURRDET=0;
    }

  int gclass=0;
  int gcount=0;
  viewport vp;
  for (int k = 0; k < last-first; ++k)
  {

    CURRIM=k;
    detections dets;
    image im;
    if (!im.read(k+first)) {
      cerr << "Unable to read in images\n";
      exit(1);
    }
    if (nist)
      nistprocess(im);
    else
    im.blur_downscale(ratio, sd);
    //clcount(im.truth()-nist)++;
    if ( showtriangles>2 )
    {
      image vim;
      vim = im;
      vim.normalize(0, numcolors - 1);
      vp.clear_geom();
      vp.add_grid(vim);
      if (showtriangles)
	{
 	  vp.add_line(point1(k, 0), point1(k, 1), point2(k, 0),
                       point2(k, 1), cyancol);
           vp.add_line(point2(k, 0), point2(k, 1), point3(k, 0),
                       point3(k, 1), cyancol);
           vp.add_line(point3(k, 0), point3(k, 1), point1(k, 0),
                       point1(k, 1), cyancol);
	}
      vp.refresh();
    }
    cout << "image " << k << endl;
    numbg=k;
    finddets(im, "", dets, "");
    totdet += dets.dim();
    // Testing if detection is good on marked images
    int gfound=0;
    if (hough==2 && regionsize > 0 && dets.dim() > 0)
    {
      // cldet(im.truth()-nist)++;
      double centx= double(point1(k,0)+point2(k,0)+point3(k,0))/3.;
      double centy= double(point1(k,1)+point2(k,1)+point3(k,1))/3.;
      //      cout << " correct center " << centx << " " << centy << endl;
      gcount++;
      int jj=0;
      while ( jj<dets.dim() && dets[jj].good == 1)
      {
        double dcentx=double(dets[jj].tripts[0]+dets[jj].tripts[2] +
                             dets[jj].tripts[4])/3.;
        double dcenty=double(dets[jj].tripts[1]+dets[jj].tripts[3] +
                             dets[jj].tripts[5])/3.;
	double dist = distance(centx, centy, dcentx, dcenty);

	if (dist < regionsize)
	{
	  cout << "Found good ONE" << endl;
	  good++;
	  break;
	}
	jj++;
      }

    }
    

    cout << "outputing detections " << endl;
   if (dumpdetections || makecoords || showtriangles)
    output_detections(vp, im, dets);

    if (segment)
	   {
	     cout << segment << endl;
	     ofstream ofs("dets");
	     int nd=dets.dim();
             varwrite(ofs,nd);

             for (int d=0; d<dets.dim(); d++)
	       {
		 dets[d].dump();
                 dets[d].locs.dump();
	       dets[d].write(ofs);
	       }
             cout << "DETECTS " << dets.dim() << endl;
	   }
    cout << " gooood " << good << endl;
  }
    if (hough==2) cout << "GOOD " << good << endl;  

    cout << "TOTAL DETECTIONS "<< totdet << endl; 
    if (viewdetections==2)
      {
	cout << CURRDET << endl;
      write_images(IMV,CURRDET);
      }
} // test_images




