// Copyright YALI AMIT, January 15, 2001.

// __________________________________________________________________________
// Declarations
extern ucgrids STAGS;
void extract_landmarks(image& im, ltatrees& ltrees, int numltas,
			 landmarks& edgelands, landmarks& ltalands);
void read_ltatrees(ltatrees& ltrees);
int read_ltatrees(ltatrees& ltrees, simpstrg direc);
void finddets(image& im, const simpstrg& pgmfile, 
               detections& det, const simpstrg& parf);
void finddets_mult(int num_models, image& imorig, const simpstrg& pgm, detections& dets,
	       const simpstrg& parf);
void edges_to_ltas(landmarks& edgelands, landmarks& ltalands, 
		   const ltatree *ltrees, int numltas);
void output_detections(viewport& vp, image& im, detections& dets);
void register_image(const image& im, partialtrans& pt, 
		     dgrid& regim, ucgrids& reglands, int *tripts, int j,
		    int cstyle, int csizex, int csizey, ucgrid& pmask,
                    int lsq, int unions = 0);
double register_and_normalize(const image& im, 
			      affinetrans& at, dgrid& regim, ucgrid& pmask, 
			      int lsq);
void register_landmarks(affinetrans& at, ucgrids& lands, int unions = 0);
int cart_against_world(dgrid& roi, const carttree* ctrees, dgrid &cartprobs, 
          ucgrids& reglands, int numiters = 1);
int cart_classify(dgrid& roi, const carttree* ctrees, ucgrids& reglands, dgrid &cp);
void init_STAGS(int size, int dimx, int dimy);
void fill_STAGS(const landmarks& lm, int spread = 0, int numt = -1);
void empty_STAGS(const landmarks& lm);
void view_edges(const image& im);
int getscale(ltatrees& ltrees, int coun, detections &tmpdets, 
              int numedgetrees, int acchits, int x1, int y1, int centx, int centy);
void hough_and_scale(image &im, const landmarks& ed, 
           const landmarks& lm, detections &tmpdets, int &currgood, 
	   ltatrees& ltrees, ltatrees& etrees);

void make_triangles(viewport& vp, detections& dets);
void register_to_dgrid(image& im, dgrid& regim, affinetrans at);
void fill_hough_areas();
void compress_dets(detections &tmpdets, int oldgood, int numfound, int &currgood);
void get_trees(partialtrans& pt, partialtrans& fpt);
void find_triangles(image& im, ltatrees& ltrees, ltatrees& etrees, int numltas,
                    landmarks& edgelands, landmarks& ltalands,
		    detections& tmpdets, int& numfound);
