// Copyright YALI AMIT, January 15, 2001.

#ifndef EDGE_H
#define EDGE_H

// __________________________________________________________________________

#include "grid.h"

class image;


extern double EdgeRatioGoodTests;
extern int EdgeRadius;
extern int EdgeInterPixelDistance;
extern double EdgeEpsilon;
extern int EdgeSizeBlock;
extern int EdgeNumberOfPixels;
extern int primitiveedges;

// __________________________________________________________________________

class Edge
{
 private:
  int Radius;
  double Epsilon;
  double RatioGoodTests;
  int InterPixelDistance;

 public:
  Edge() { }
  Edge(int radius, int inter, double rgt, double eps);
  void init(int radius, int inter, double rgt, double eps);
  ~Edge() { }
  void DetectEdges(const image& im, landmarks& lmarks, int unions = 0);
  void FindEdgesInTheBlock(const image &im, int x, int y, 
			   int& NbEdgesInTheBlock, igrid &TabEdges,
                           int unions);
  void FindEdgesInTheBlock(igrids &gradim, int x, int y, 
			   int& NbEdgesInTheBlock, igrid &TabEdges,
                           int unions);
  int NbLandmarks;

}; // class Edge

#endif // EDGE_H

