// Copyright YALI AMIT, January 15, 2001.

#ifndef GLOBLIST_H
#define GLOBLIST_H
#endif


// List of global variables along with initial values


// Trick to allow for variable arg defines
#define _ ,

GLOBALA(int, useques, 20, 0 _ 1 _ 1)
GLOBALA(simpstrg, facenames, 300, "")

// Temporary dummy variables useful for testing code;  Anything can be
// done with them at any time
GLOBALI(double, alpha, 0)
GLOBAL(double, alpha1)
GLOBAL(double, alpha2)
GLOBAL(int, dum1)
GLOBAL(int, dum2)
GLOBALI(int, pad, 40)
// Options controlling the current run of the program
GLOBAL(int, opt)                // Main option for running the program
GLOBAL(int, viewopt)            // Options used when viewing objects
GLOBAL(int, extension)          // Used to index repeated runs of the program
GLOBAL(long, seed)              // The random number generator seed

// Input/Output file names
GLOBALI(simpstrg, datadir, "/opt/data/")  // Directory containing data
GLOBALI(simpstrg, landdir, "")
GLOBALI(simpstrg, newlanddir, ".")
GLOBALI(simpstrg, maskdir, ".")

GLOBALI(simpstrg, dataset, ".") // A particular data set
GLOBAL(simpstrg, dumpfile)     // Output file containing all global values
GLOBAL(simpstrg, parfile)      // Input file containing global initializers
GLOBAL(simpstrg, tempfile)    //For templates.
GLOBALI(simpstrg, detfile, "")    // For output detections
GLOBAL(simpstrg, listfile)     // File with a list of digits indices
GLOBAL(simpstrg, treefile)     // Name of binary tree file
     GLOBALI(simpstrg, fontname, "9x15") // Font to use in displays
     GLOBALI(int, numdets, 0) // Number of detections
GLOBALI(int, segment, 0)
GLOBALI(double, basecol, 0) // COlor for curves and points
GLOBALI(double, imrange, 0) // COlor for curves and points

// Sparse Detection parameters.
GLOBALI(int, onlyedges, 0) // Use only edges for the hough transform
GLOBALI(int, edgesforscale,1) // Use edges for adjusting scale (0=use ltas)
GLOBALI(int, coarse, 0) // If > 0 downscale LTA parameters to lower res.
GLOBALI(int, ltacluster, 5) // Otherwise cluster LTA's at original res.
GLOBALI(double,botpercent,.72) // Range of scales covered by the
GLOBALI(double,toppercent,1.28) // hough transform regions
GLOBALI(double, lowscale,.8) // Range of scales to try at a 
GLOBALI(double, highscale,1.2) // candidate location
GLOBALI(int, locshift,2) // Range of shift to try a candidate location
GLOBALI(int, edgespread,1) // Spread of edges used for adjusting scale.
GLOBALI(int, templatestyle, 0) // Type of algorithm to implement initialized
                               // with detection

GLOBALI(int, showbest, 0) // Show best pose at each detection
GLOBALI(double, houghpar1, 0) // Parameters for showing in workings
GLOBALI(double, houghpar2, 0) // of hough transform

     
//  Display parameters
GLOBALI(int, datadepth, 8)     // Number of bits per pixel in the data
GLOBALI(int, datasize, 0)      // Number of images in the dataset
GLOBALI(int, numcolors, 64)
GLOBALI(int, imborder, 5)
GLOBALI(int, pixsize, 1)


GLOBALI(int, far, 4)
GLOBALI(int, filter, 1)
GLOBALI(int, numlevels, 10)
GLOBAL(int, findedges)
GLOBAL(int, first)
GLOBALI(int, imagesperfile, 100)

// Classification tree parameters
GLOBALI(simpstrg, impmeasure, "entropy")
GLOBAL(int, initdataopt)
GLOBALI(int, instdist, 3)
GLOBAL(int, last)
GLOBAL(int, maxcodelength)
GLOBALI(int, maxdepth, 30)
GLOBALI(int, maxinst, 20000)
GLOBALI(int, minang, 0)
GLOBALI(int, minland, 0)
GLOBALI(int, mindis, 1)
GLOBALI(int, mintol, 0)
GLOBALI(int, numang, 16)
GLOBALI(double, anginc, 0)
GLOBALI(double, reltolerance, 0)
GLOBALI(int, numedges, 8)
GLOBAL(int, numland)
GLOBALI(int, numdis, 1)
GLOBALI(int, numtol, 1)
GLOBALI(int, mindata, 1)
GLOBAL(double, minentdrop)
GLOBAL(int, minpernode)
GLOBALI(int, modetwo, 5)
GLOBALI(int, numloc, 200)
GLOBALI(int, near, 4)
GLOBAL(int, numdata)
GLOBALI(double, objprop, .5)
GLOBALI(int, numdigits, 1)
GLOBALI(int, numtrain, 1)
GLOBALI(int, numtest, 1)
GLOBALI(int, numclass, 1)
GLOBALI(int, classlabel, -1)
GLOBALI(int, numlatex, 0)
GLOBAL(int, numtreedata)
GLOBAL(int, numquesask)
GLOBAL(int, numquesdata)

GLOBALI(double, purepar, 1.0)
GLOBAL(int, randomize)
GLOBALI(double, ratio, 1.0)
GLOBALI(double, sd, 1.0)
GLOBAL(double, rotate)
GLOBALI(double, scale, 0)
GLOBAL(int, showorig)
GLOBALI(int, hough, 0)
GLOBAL(int, showpixels)
GLOBAL(double, skew)
GLOBALI(int, slant, 0)
GLOBAL(int, tmptreedata)
GLOBALI(int, revvideo, 1)
GLOBALI(int, reverseimage,0)
GLOBALI(int, colors, 0)
GLOBALI(int, BGD, 0)
// When registering images, three distinguished points are chosen
// from each training image.  The average values of theses points
// are calculated and stored as indicated in the following variables
GLOBAL(int, vector1x)   // average vector joining points 1 and 2
GLOBAL(int, vector1y)
GLOBAL(int, vector2x)   // average vector joing points 1 and 3
GLOBAL(int, vector2y)
GLOBALI(double, boxfactorx, 1) // ad-hoc border calculation used to modify
GLOBALI(double, boxfactory, 1) // the registration into a nxn grid
GLOBALI(int, point1x, 3)    // average point1 location in nxn grid
GLOBALI(int, point1y, 3)
GLOBALI(int, point2x, 12)    // average point2 location in nxn grid
GLOBALI(int, point2y, 3)
GLOBALI(int, point3x, 8)    // average point3 location in nxn grid
GLOBALI(int, point3y, 12)
GLOBALI(int, epoint1x, 0)
GLOBALI(int, epoint1y, 0)
GLOBALI(int, epoint2x, 0)
GLOBALI(int, epoint2y, 0)
GLOBALI(int, epoint3x, 0)
GLOBALI(int, epoint3y, 0)
GLOBALI(int, fpoint1x, 6)
GLOBALI(int, fpoint1y, 6)
GLOBALI(int, fpoint2x, 24)
GLOBALI(int, fpoint2y, 6)
GLOBALI(int, fpoint3x, 16)
GLOBALI(int, fpoint3y, 24)
GLOBALI(int, defpoint1x, 6)
GLOBALI(int, defpoint1y, 6)
GLOBALI(int, defpoint2x, 24)
GLOBALI(int, defpoint2y, 6)
GLOBALI(int, defpoint3x, 16)
GLOBALI(int, defpoint3y, 24)
     GLOBALI(int,defsizex,32)
     GLOBALI(int,defsizey,32)
GLOBALI(int, ltatree1x, 39)    // average ltatree point1 location
GLOBALI(int, ltatree1y, 39)
GLOBALI(int, ltatree2x, 52) // average ltatree point2 location
GLOBALI(int, ltatree2y, 39)
GLOBALI(int, ltatree3x, 46) // average ltatree point3 location
GLOBALI(int, ltatree3y, 52)

// Hard wired Local feature parameters - edge.C
GLOBALI(int, merge, 0)
GLOBALI(int, spreadforpair, -1)
GLOBALI(double, EdgeType, 0)
GLOBALI(int, EdgeGoodTests, 5)
GLOBALI(int, EdgeRadius, 5)
GLOBALI(int, EdgeInterPixelDistance, 1)
GLOBALI(double, EdgeEpsilon, 0.03)
GLOBALI(int, EdgeSizeBlock, 2)
GLOBALI(int, EdgeNumberOfPixels, 1)
GLOBALI(int, primitiveedges,0)
GLOBALI(int, cluster, 0) 
// Parameters for coded binary microimages
GLOBAL(int, codesize)
GLOBAL(simpstrg, codesfile)
GLOBAL(simpstrg, codetreefile)

GLOBALI(int, clutter, 0)
GLOBALI(int, regionsize, 5)
GLOBALI(int, regionminx, -1)
GLOBALI(int, regionminy, -1)
GLOBALI(int, regionmaxx, 10000)
GLOBALI(int, regionmaxy, 10000)
GLOBALI(int, buildtree, 1)
GLOBALI(int, class_tree, 0)
GLOBALI(int, starcenterx,-1)
GLOBALI(int, starcentery,-1)
GLOBALI(int, separation, 1)
GLOBALI(int, ltasep, 0)

GLOBALI(int,firstclass,-1)
GLOBALI(int,secondclass,-1)
GLOBALI(int, numperts, 3)
GLOBALI(int, firstlta, 0)
GLOBALI(int, numltas, 9)
GLOBALI(int, simple, 0)
GLOBALI(simpstrg, ltatreedir, "treesgood")
GLOBALI(simpstrg, carttreedir, "treescart")
GLOBALI(simpstrg, fcarttreedir, "facecart")
GLOBALI(simpstrg, edgetreedir, "treesedge")

GLOBALI(int, firstratio, 0)
GLOBALI(int, firsttree, 0)
GLOBALI(int, numratios, 5)
GLOBALI(int, numbg, 1000)
GLOBALI(int, itersize, 10)
GLOBALI(int, firstiter, 0)
GLOBALI(int, cartiters, 1)
GLOBALI(int, numcarts, 0)
GLOBALI(int, fnumcarts, 0)
GLOBALI(int, wholecarts, 0)
GLOBALI(int, carthistsize, 10)
GLOBALI(int, ltahistsize, 10)
GLOBALI(int, althistsize, 0)
GLOBALI(int, vote, 0)
GLOBALI(int, nist, 0)


GLOBALA(double, focusr, 5, -1 _ -1 _ -1 _ -1 _ -1)
GLOBALI(double, lrratio, 0)

GLOBALI(int, numperclass, 0)          // True if data is latex images
GLOBALI(int, latexexp, 0)          // True if data is latex images
GLOBALI(int, latexdim, 32)          // Dimension of  latex images
GLOBAL(int, showedges)             // Display edges
GLOBAL(int, showltas)              // Display ltas
GLOBALI(int, showfaces, 1)         // Display faces
GLOBALI(int, boxcluster, 0)
GLOBALI(int, tricluster, 0)
GLOBALI(int, boxmethod, 0)
GLOBALI(int, facecontrast, 0)
GLOBALI(int, tridist, 2)
GLOBALI(int, normalstyle, 0)
GLOBALI(int, ltausedepth, -1)
GLOBALI(int, spread, 0)
GLOBALI(int, cartspread, 1)
GLOBALI(int, hits, 1)
GLOBALI(int, usemasks, 1)
GLOBALI(int, ellipses, 1)
GLOBALI(int, showellipses, 0)
GLOBALI(int, showellipses1, 0)
GLOBALI(int, showboxes, 0)
GLOBALI(int, showtriangles, 0)
GLOBAL(simpstrg, pgmfile)

GLOBALI(double, eyecost, 1)
GLOBALI(double, facecost, .8)

GLOBALI(int, boost, 0)
GLOBALI(int, cartstyle, 0) // 0 = normal, 1 = diffs, 2 = edges, 3 = ltas
GLOBALI(int, fcartstyle, 0) // 0 = normal, 1 = diffs, 2 = edges, 3 = ltas
GLOBALI(int, synthesize, 0)
GLOBALI(int, filter_size, 3)
GLOBALI(int, mindepth, 3)
GLOBALI(int, maxdetects, 10000)
GLOBALI(int, dumpdetections, 0)
GLOBALI(int, viewdetections, 0)

GLOBALI(int, cartsizex, 16)
GLOBALI(int, cartsizey, 16)
GLOBALI(int, fcartsizex, 16)
GLOBALI(int, fcartsizey, 16)
GLOBALI(double, threshold, 0.)
GLOBALI(int, pertamount, 5)
GLOBALI(int, DIMX, 0)
GLOBALI(int, DIMY, 0)
GLOBALI(int, firstreg, 0)
GLOBALI(int, lastreg, 100)
GLOBALI(int, numedgetrees, 200)
GLOBALI(int, poolnumuse, 2)
GLOBALI(int, acchits, 0)
GLOBALI(double, accfactor, 1.)
GLOBALI(double, segprop, .75)
GLOBALI(double, seglamda, 0.)
GLOBALI(int, filllevels, 0)

GLOBALI(int, MRI, 0)
GLOBALI(int, shift, 40)
GLOBALI(int, edgeinc, 2)
GLOBALI(int, pointcolor, 1)
GLOBALI(int, masktype, 0)
GLOBALI(int, fmasktype, 0)
GLOBALI(int, leastsquares, 0)
GLOBALI(int, fleastsquares, 0)
GLOBALI(int, fcart2, 0)
GLOBALI(int, writedgrids, 0)
GLOBALI(int, makecoords, 0)
GLOBALI(int, eyex, 0)
GLOBALI(int, eyey, 0)
GLOBALI(int,firstmodel,0)
GLOBALI(int, check_type,0)
GLOBALI(int, check_radius, 2)

// Twod elastic deformation parameters, Guassian and Bernoulli models
GLOBALI(simpstrg, tempdataset, ".") // A particular data set
GLOBALI(int,tempnum,0)
GLOBALI(int, linear_elas, 0)
GLOBALI(int, displayinter,10)
GLOBALI(double, minenergychange, .02)
GLOBALI(int, LBX, 0)
GLOBALI(int, LBY, 0)
GLOBALI(int, LASTDIM, 0)
GLOBALI(int, FIRSTDIM, 0)
GLOBALI(double, dt_scale_factor,1.)
GLOBALI(int ,newres, 0)
GLOBALI(int, base, 3)
GLOBALI(int, numiters, 100)
GLOBALI(double, prior_fac, 0)
GLOBALI(double, post, 0)
GLOBALI(int, arrow_spacing, 4)
GLOBALI(double,minval,.1)
GLOBALI(double,maxval,.9)


// Dynamic programming parameters
GLOBALI(int,dyna_regionsize,10)
GLOBALI(int,dyna_dis,1)
GLOBALI(double,prior_angle,.01)
GLOBALI(double,prior_length,.01)

// Deformable contour parameters
GLOBALI(int,curve_length,0)
GLOBALI(int,shiftx,-1)
GLOBALI(int,shifty,0)
GLOBALI(double,inside,.95)
GLOBALI(double,outside,0.05)
GLOBAL(int, testrotations)

// Curve Tracking parameters
GLOBALI(int,LEN,10)
GLOBALI(int,ORTHLEN,4)
GLOBALI(int,deg,10)
GLOBALI(int,numtrack,5)
GLOBALI(double,ZSTAR,.999)

// Global size parameters
GLOBALI(int, Jmax, 100000)
GLOBALI(int, maxlands, 100000)
GLOBALI(int, STAGSsize, 8)
GLOBALI(int, STAGSdim, 1000)
GLOBALI(int, q1insts, 10000)
GLOBALI(int, q2insts, 10000)

// Elliot's additions
GLOBALI(simpstrg, nodespec, "")
GLOBALI(double,mu,0.1) // mu for level set algorithm
GLOBALI(double,radius,5) // radius is image diagonal length / value
GLOBALI(double,tol,0.005) // tolerance for level set algorithm
GLOBALI(double, sameprob, 1./3.) // prior probability on tree branches
                                 // with the same angle (for roadtrack)
GLOBALI(simpstrg, priordist, "unif") // prior distribution on the tree 
GLOBAL(simpstrg, q7file)
GLOBALI(int, q7dim, 1000)

GLOBALI(int, centerink, 0) // If one, detected subimages in getRandomSubregions
                           // are required to have ink at the center location
GLOBALI(int, centeredge, 1) // If one, detected subimages in 
                            // getRandomSubregions are required to have 
                            // an edge detected at the center location
GLOBALI(int, clustalg,2)
GLOBALI(int, numclusters,10) // Number of clusters for kMeans
GLOBALI(simpstrg, centroidfile, "Centroids")
GLOBALI(simpstrg, centroiddir, ".")
GLOBAL(int, numCuts)
GLOBAL(int, numPairs) 
GLOBALI(simpstrg, cutfile, "cutoffs.txt")
GLOBALI(int, gridDim, 4)
GLOBALI(int, gridSpacing, 4)
GLOBALI(simpstrg, centroidinfile, "")

GLOBALI(simpstrg, trainlanddir, ".")
GLOBALI(simpstrg, testlanddir, ".")

GLOBALI(simpstrg, inlanddir, ".")
GLOBALI(simpstrg, outlanddir, ".")
GLOBALI(int, firstclust, 0)
GLOBALI(int, writeerrors,0)

#undef _

// __________________________________________________________________________
// globlist.h
