// Copyright YALI AMIT, January 15, 2001.

#ifndef LATEX_C
#define LATEX_C


//___________________________________________________________________________

#include <iostream>
#include <cstdio>

#include "includes.h"
#include "pixel.h"
#include "grid.h"
#include "trainstat.h"
#include "globals.h"
#include "viewport.h"
#include "viewgrid.h"
//___________________________________________________________________________
// Option 47
// Make database of latex images
#define log2(a) log((double)a)/log(2.)
void make_latex_images();
void make_latex_images()
{
void synth(image &im, int p10 = -1, int p11 = -1, int p20 = -1, int p21 = -1,
int p30 = -1, int p31 = -1);

 void makevec (int N);
  // Read and scale the registration points of the training images.
 //  synthesize = 1;
  igrid point1, point2, point3;
  int po = 0;
 
  po  = read_coords(point1, point2, point3, ratio, first, last+1);
 
  int subsize=regionsize;
  int imw;
  if (latexdim==0)
     imw = 32;
  else
     imw=latexdim;
  if (synthesize==1)
      makevec(base);  
  image imorig;
  int coun=0;
  
  Ofstream(co, "coords");
  if (!co)
  {
    cerr << "Unable to open coords... Exiting" << endl;
    exit(1);
  }
  
  Ifstream(col, "clustlist");
  vector<image> imv( numdigits * (last - first + 1));  
  for (int num=first; num<=last; num++)
    {
      int kk;
      if (!col)
	imorig.read(num);
      else
	{
	  col >> kk;
	  imorig.read(kk);
	}
      imorig.normalize(255);
      if (reverseimage==1)
	gridfun(255-imorig(i,j),imorig);
      //      BGD=imorig(imorig.dimx()-1, imorig.dimy()-1);
      BGD=0;
      cout << " BGD " << BGD << endl;
      if (ratio==1.)
	imorig.blur_downscale(1., sd);
      else
	imorig.blur_downscale(ratio,sd);
      for (int k = 0; k < numdigits; ++k)
	{
	  image im=imorig;
	  int p10=0, p11=0, p20=0, p21=0, p30=0, p31=0;
	  if (po)
	    {
	      p10=point1(num-first, 0); p11=point1(num-first, 1); p20=point2(num-first, 0);
	      p21=point2(num-first, 1); p30=point3(num-first, 0); p31=point3(num-first, 1);
	    }
	  
	  
	  
	  if (imw < 1000)
	    {
	      
	      if (synthesize)
		{
		  int l2imw=int(rint(log2(imw)))+1;
		  l2imw=pow(2,l2imw);
		  image tim(l2imw,l2imw);
		  tim.clear();
		  int hd2 = MAX(l2imw-MAX(im.dimx(),im.dimy()),0)/2;
		  tim.subcopy(0,im.dimx(),0,im.dimy(),im,hd2,hd2);
		  p10+=hd2; p11+=hd2; p20+=hd2; p21+=hd2; p30+=hd2; p31+=hd2;
		  synth(tim, p10, p11, p20, p21, p30, p31);
		  
		  im=tim;
		}
	      if (randomize>0)
		{
		  im.imtrim(5, p10,p11,p20,p21,p30,p31);
		  
		  im.std_process(skew, rotate, slant, scale, p10,p11,p20,p21,p30,p31);
		  
		  im.imtrim(-imw, p10,p11,p20,p21,p30,p31);
		}
	      
	      if (shiftx>0)
		{
		  int loctransx = int( shiftx*double(500-(rand() % 1000))/(1000));
		  int loctransy = int(shiftx*double(500-(rand() % 1000))/(1000));
		  im.shift(loctransx, loctransy, p10, p11, p20, p21, p30, p31);
		}
	      if (clutter)
		{
		  int x;
		  im.imtrim(-imw,x,x,x,x,x,x);
		  for (int c=0; c<clutter; c++)
		    {
		      int regionsizex=regionmaxx;
		      int regionsizey=regionmaxy;
		      image imc,imc1(regionsizex,regionsizey);
		      int rn = rand() % last;
		      imc.read(rn);
		      imc.blur_downscale(1., sd);
		      //view_normalized(imc);
		      int xx=imc.dimx()/2;
		      int yy=imc.dimy()/2;
		      int xx1=drand48() * im.dimx();
		      int yy1=drand48() * im.dimy();
		      
		      //		      view_normalized(im);
		      
		      for (int i=0; i<regionsizex; i++)
			for (int j=0; j<regionsizey; j++)
			  {
			    //		   if (imc.get(xx1+i,yy1+j) > 0)
			    {
			      im.set(xx1+i, yy1+j, MAX(imc.get(xx+i, yy+j), im.get(xx1+i, yy1+j)));
			    }
			  }
		    }
		  
		  //im.imtrim(-imw, p10,p11,p20,p21,p30,p31);     
		  //view_normalized(im);
		}
	      
	      
	      
	      if (threshold > 0.)
		{
		  gridfun(im(i,j) > 255*threshold, im);
		}
	      if (reverseimage>=1)
		gridfun(255-im(i,j),im);
	      
	      if (subsize)
		{
		  int xx=rand() % (im.dimx()-subsize);
		  int yy=rand() % (im.dimy()-subsize);
		  imv[coun].init(subsize,subsize);
		  gridfun(im(xx+i,yy+j),imv[coun]);
		  co << 0 << " " << 0 << "\n"
		     << subsize << " " << 0 << "\n"
		     << subsize/2 << " " << subsize << "\n";
		  //(imv[coun]).imtrim( 2, p10,p11,p20,p21,p30,p31);
		}
	      else
		imv[coun]=im;
	      if (po)
		{
		  co << p10 << " " << p11 << "\n"
		     << p20 << " " << p21 << "\n"
		     << p30 << " " << p31 << "\n";
		}
	      
	      if (subsize || first==last)
		imv[coun].set_truth(1);
	      else
		//imv[coun].set_truth(num);
		imv[coun].set_truth(imorig.truth());
	      //imv[coun].set_truth(1);
	      coun++;
	    }
	  else 
	    {
	      imv[coun]=im;
	      imv[coun].set_truth(1);
	      if (po)
		{
		  co << p10 << " " << p11 << "\n"
		     << p20 << " " << p21 << "\n"
		     << p30 << " " << p31 << "\n";
		}
	      coun++;
	    }
	}
    }
  
  co.close();
  
  write_images(imv, coun);
  
} // make_latex_images

//___________________________________________________________________________
// latex.C

#endif // LATEX_C


