// Copyright YALI AMIT, January 15, 2001.



// __________________________________________________________________________
// Includes

#include "includes.h"
#include "question.h"
#include "avlgrid.h"
#include "ltatree.h"
#include "globals.h"


extern ucgrids STAGS;
extern ucgrids edgemats;
// __________________________________________________________________________
// Function prototypes

void get_best_q1(question& que, lgrid& qlist, lgrid& dlist, 
		 const lmarkslist& lmarks, double& ent); 
int check_q1(relation& rel, const landmarks& lmarks);
 int newcheck(int dx, int dy, relation& rel);
// __________________________________________________________________________

void get_best_q1(question& que, lgrid& qlist, lgrid& dlist, 
		 const lmarkslist& lmarks, double& ent)
{
  if (qlist.dimx() == 0)
    return;

  int index = 0;
  int counter = 0;
  relation rel;
  for (rel.ang = minang; rel.ang < minang + numang; ++rel.ang)
    for (rel.tol = mintol; rel.tol < mintol + numtol; ++rel.tol)
      for (rel.dis = mindis; rel.dis < mindis + numdis; ++rel.dis)
	for (rel.land1 = minland; rel.land1 < minland + numland; ++rel.land1)
	   for (rel.land2 = minland; rel.land2 < minland + numland; ++rel.land2)
	  {
	    if (index == qlist.dimx())
	      return;
	    // if (rel.land1 == rel.land2)
            //  continue;
	    else if (qlist(index) == counter++)
	    {
	      ltahist yes, no;
	      for (int i = 0; i < dlist.dimx(); ++i)
	      {
		if (check_q1(rel, lmarks[dlist(i)]))
		  ++yes[lmarks[dlist(i)].truth(nist)];
		else
		  ++no[lmarks[dlist(i)].truth(nist)];
	      }

	      double newent;
	      if (class_tree==0)
		newent = 1000000 - yes.total();
              else
                newent = ave_impurity(yes, no);
	      //cout << " newques ";
	      //cout << rel.land1 << " " << rel.land2 << " " << (int)rel.ang << " "  << 1000000-newent<< endl;
              
	      if (newent < 1000000 && newent <= ent && (rand() % 1000 > 500) ) {
		ent = newent;
		que.typ = 1;
		que.r1 = rel;
		if (no.total() == 0)
		  return;
	      }
	      ++index;
	    }
	  }

} // get_best_q1

// __________________________________________________________________________
// Determine if there is an instance of a type 1 question

int check_q1(relation& rel, const landmarks& lmarks)
{
  int num1 = lmarks.type_count(rel.land1);

  int num2 = lmarks.type_count(rel.land2);
  //cout << " num2" << num2 << endl;

  for (int i = 0; i < num1; ++i)
    {
      int l1x = lmarks.location_x(rel.land1, i);
      int l1y = lmarks.location_y(rel.land1, i);

      
	//cout << class_tree << " " << buildtree << endl;
      if (class_tree || (l1x >= regionminx && l1x <= regionmaxx && l1y >= regionminy && l1y <= regionmaxy) )
	{
         
	  for (int j = 0; j < num2; ++j)
	    {   
	      int l2x = lmarks.location_x(rel.land2, j);
	      int l2y = lmarks.location_y(rel.land2, j);
	      
	      
	      
	      int dx=l2x-l1x;
	      int dy=l2y-l1y;
	      

	      if (newcheck(dx,dy,rel))
		return 1;
	    }
	}
    }
  return 0;
  
} // check_q1

// __________________________________________________________________________
// Determine all instances of a type 1 question.

int upd_inst1(relation& rel, const landmarks& lmarks, igrid& instances)
{
  static iavlgrid tmpinsts;
  static ivector l(4);

  //  cout << "ltasep " << ltasep << endl;
  static int inited = 0;
  if (!inited) 
  {
    inited = 1;
    tmpinsts.ainit(q1insts, 4);
  }
  else
    tmpinsts.reinit();

  int foundinst = 0;
  // Loop through all occurrence of landmarks of type 1
  int i, num1 = lmarks.type_count(rel.land1);
  for (i = 0; i < num1; ++i)
  {
    int foundstar = 0;
    l[0] = lmarks.location_x(rel.land1, i);
    l[1] = lmarks.location_y(rel.land1, i);
  
    
     if (regionminx<0 || class_tree || (l[0] >=  regionminx && l[0] <= regionmaxx && l[1] >= regionminy && l[1] <= regionmaxy ))
    {
     
      // searchpix is the number of pixels where a landmark of type 
      // rel.land2 can be found which will satisfy the relation.
      // 'relmasksx' and 'relmasksy' store the offsets to these locations.
      int searchpix = relmasksx(rel.ang, 0);
      for (int j = 1; j < searchpix && foundinst < maxinst && !foundstar; ++j)
	{
	    
	  l[2] = l[0] + relmasksx(rel.ang, j);
	  l[3] = l[1] + relmasksy(rel.ang, j);
	
	  if (STAGS[rel.land2].get(l[2], l[3]))
	    {
	      int logic=tmpinsts.tooclose(l, ltasep);

	      if (!logic)
		{ 
		  tmpinsts.insert(l);

		  // for (int ii = 0; ii < 4; ++ii)
		  //  tmpinsts(foundinst, ii) = l[ii];
		  ++foundinst;
		  if (!class_tree)
		    ++foundstar;
		}
	    }
	}
    }
  }
    
  if (foundinst)
    {
      instances.init(4, foundinst);
      for (i = 0; i < 4; ++i)
	for (int j = 0; j < foundinst; ++j)
	  instances(i, j) = tmpinsts(j, i);
    }
  
  return foundinst;
  
}

// __________________________________________________________________________
// q1.C
