// Copyright YALI AMIT, January 15, 2001.



// __________________________________________________________________________
// Includes

#include "includes.h"
#include "question.h"
#include "avlgrid.h"
#include "ltatree.h"
#include "globals.h"


extern ucgrids STAGS;
extern ucgrids edgemats;
// __________________________________________________________________________
// Function prototypes
static igrids INDEX;
static igrid list;
//static vector<iavlgrid> tmpinsts;
static igrids tmpinsts;
int numtyp=-1;
int upd_inst2a(relation& rel, const landmarks&,
	       const igrid& oldinst, igrid& newinst);
int q1d1(landmarks& lmarks, igrids& instances)
{

  if (!INDEX.dim())
    {
      INDEX.init(40);
      for (int k=0; k<INDEX.dim(); k++)
	{
	  INDEX(k).init(8,8);
	  INDEX(k).clear(-1);
	}
    }
  static ivector l(5);


  
  if (numtyp<0)
    {
      simpstrg dir=ltatreedir+("/ddl1u");
      ifstream ifs;
      ifs.open(dir);
      if (!ifs)
	{
	  simpstrg ss=simpstrg("getlts ")+ltatreedir;
	  system(ss);
	  ss=simpstrg("mv ddl1u ")+ltatreedir;
	  system(ss);
	  ifs.open(dir);
	}
      ifs >> numtyp;
      tmpinsts.init(numtyp);
      list.init(numtyp,3);
      for (int k=0; k<numtyp; k++)
	{
	  for (int l=0; l<3; l++)
	    {
	      ifs >> list(k,l);
	    }
	  if (list(k,1)<INDEX.dim())
	    INDEX[list(k,1)](list(k,0),list(k,2))=k;
	  else
	    {
	      cerr << " Too many angles " << endl;
	      exit(0);
	    }
	}
   
      
      for (int k=0; k<numtyp; k++)
	{
	  //	  tmpinsts[k].ainit(q1insts, 5);
	  tmpinsts[k].init(q1insts, 5);
	}
    }
  else
    {
      //for (int k=0; k<numtyp; k++)
      //	{
      //	  tmpinsts[k].reinit();
      //	}
    }

  instances.init(numtyp);
  // Loop through all occurrence of landmarks of type 1
  for (int typ=0; typ < numtyp; typ++)
    {
      int foundinst = 0;
      int e1=list(typ,0);
      int ag=list(typ,1);
      int e2=list(typ,2);
      int num1 = lmarks.type_count(e1);
  
      for (int i = 0; i < num1; ++i)
	{
	  int foundstar = 0;
	  l[4] = int(lmarks.spill(e1,i));
	  l[0] = lmarks.location_x(e1, i);
	  l[1] = lmarks.location_y(e1, i);
	  int searchpix = relmasksx(ag, 0);
	  for (int j = 1; j < searchpix && 
		 foundinst < q1insts && !foundstar; ++j)
	    {
	      l[2] = l[0] + relmasksx(ag, j);
	      l[3] = l[1] + relmasksy(ag, j);
	      int dif=STAGS[e2].get(l[2], l[3]);
	      if (dif)
		{
		  //int logic=tmpinsts[typ].tooclose(l, ltasep);
		    { 
		      //tmpinsts[typ].insert(l);
		      for  (int r=0; r<5; r++)
		       tmpinsts[typ](foundinst,r)=l[r];
		      ++foundinst;
		      if (!class_tree)
			++foundstar;
		    }
		}
	    }
	}

      if (foundinst)
	{
	  instances[typ].init(5, foundinst);
	    for (int j = 0; j < foundinst; ++j)
	      {
		instances[typ](0,j)=tmpinsts[typ](j,4);
		for (int i = 0; i < 4; ++i)
		  {
		    instances[typ](i+1, j) = tmpinsts[typ](j, i);
		  }
	      }
	}
     
    }
 
}

// For testing - drop a data point down a tree 
void ltatree::dropdata_fromlist(landmarks& lmarks, ltaiter& terminal, 
				igrid& newinst, igrids& preinsts) 
{
  
  
  anginc = 2 * PI / tnumang;
  reltolerance = anginc;
  terminal = top();
  
  question qu=terminal->que;
  int ind=INDEX[qu.r1.ang](qu.r1.land1, qu.r1.land2);
  //  cout << "qu " << int(qu.r1.ang) << " " << qu.r1.land1 << " " << qu.r1.land2 << " ind " << ind << endl;
  igrid tmpinst;
  int currdepth = 0;
  newinst=preinsts[ind];
  terminal=terminal.yes();

  while (terminal.branch() && (ltausedepth == -1 || ltausedepth > currdepth++))
  {

    qu=terminal->que;
   
    if (upd_inst2a(qu.r1, lmarks, newinst, tmpinst))
      terminal = terminal.yes();
    else 
      terminal = terminal.no();
    newinst << tmpinst;
   
  }
}

int upd_inst2a(relation& rel, const landmarks&,
	      const igrid& oldinst, igrid& newinst)
{
  int i, j, k;
  int foundinst = 0;
  static igrid tmpinsts;
  static int inited = 0;
  if (!inited)
  {
    inited = 1;
    tmpinsts.init(3, q2insts);
  }
  
  int numinst = oldinst.dimy(); 
  //  cout << " IN upd " << numinst << endl;
  // Only change from...
  int numverts = (oldinst.dimx()-1) / 2;
  for (i = 0; i < numinst; ++i)
  {
    int foundstar = 0;
    // Only difference from update_q2
    int l1x = oldinst(rel.v1 * 2 + 1, i);
    int l1y = oldinst(rel.v1 * 2 + 2, i);
    //cout  << " ll1s " << l1x << " " << l1y << endl;
    int searchpix = relmasksx(rel.ang, 0);
    for (k = 1; k < searchpix && foundinst < maxinst && !foundstar; ++k)
    {
      int l2x = l1x + relmasksx(rel.ang, k);
      int l2y = l1y + relmasksy(rel.ang, k);
      if (STAGS[rel.land1].get(l2x, l2y))
      {
	int tooclose = 0;
	// Make sure the new location isn't too close to any other
        //   points in the current instance.
        if (separation)
	  {
	    for (j = 0; j < numverts && !tooclose; ++j)
	      {
		// Only difference from update_q2
		int l0x = oldinst(2 * j + 1, i);
		int l0y = oldinst(2 * j + 2, i);
		// cout  << " ll0s " << l0x << " " << l0y << endl;
		//int tooclose2=linfdist(l0x, l0y, l2x, l2y);
		//int tooclose1 = (linfdist(l0x, l0y, l2x, l2y) < separation);
		tooclose = ((l0x==l2x) && (l0y==l2y));
		//if (tooclose!=tooclose1)
		//  cout << separation << " " << tooclose << " " << tooclose1 << " " << tooclose2 << endl;
	      }
	  }
	    int toonear = 0;
	// Make sure the new location isn't too close to other
	// locations already found for new vertex at current old-instance (i)
	    /*
	for (j = 0; j < foundinst && !toonear && class_tree; ++j)
	  {
	    int l0x = tmpinsts(1, j);
	    int l0y = tmpinsts(2, j);
	    toonear = (linfdist(l0x, l0y, l2x, l2y) < ltasep);
	  }
	    */
	if (!tooclose && !toonear)
	{
	  tmpinsts(0, foundinst) = i;
	  tmpinsts(1, foundinst) = l2x;
	  tmpinsts(2, foundinst) = l2y;
	  ++foundinst;
	  if (!class_tree)
	  ++foundstar;
	}
      }
    }
  }


  if (foundinst)
  {
    newinst.init(oldinst.dimx() + 2, foundinst);
    for (j = 0; j < foundinst; ++j)
    {
      for (i = 0; i < oldinst.dimx(); ++i)
	{
	  newinst(i, j) = oldinst(i, tmpinsts(0, j));
	}
      for (i = 0; i < 2; ++i)
	newinst(oldinst.dimx() + i, j) = tmpinsts(i + 1, j);
    }
  }
  else
    {
      if (class_tree)
	newinst = oldinst;
      else
	newinst.init();
    }
 
  return foundinst;
}
// __________________________________________________________________________
// q1a.C





