// Copyright YALI AMIT, January 15, 2001.



// __________________________________________________________________________
// Includes

#include "includes.h"
#include "question.h"
#include "ltatree.h"
#include "globals.h"

extern ucgrids STAGS;
extern ucgrids edgemats;
extern int xang[8],yang[8];
// __________________________________________________________________________
// Function prototypes

void get_best_q2(question& que, lgrid& qlist, lgrid& dlist, 
		 const lmarkslist& lmarks, igrid& vertlist, 
		 const igrids& instances, double& ent);
int check_q2(relation& rel, const landmarks& lmarks, const igrid& instances);
// __________________________________________________________________________
int newcheck(int dx, int dy, relation& rel);

void get_best_q2(question& que, lgrid& qlist, lgrid& dlist, 
		 const lmarkslist& lmarks, igrid& vlist, 
		 const igrids& instances, double& ent)
{
  if (qlist.dimx() == 0)
    return;

  int index = 0;
  int counter = 0;
  relation rel;

  //vlist.dump();
  int maxv=vlist.dimx()/2;
  if (!class_tree)
      maxv=1;

  for (rel.ang = minang; rel.ang < minang + numang; ++rel.ang)
    for (rel.land1 = minland; rel.land1 < minland + numland; ++rel.land1)
      for (rel.v1=0; rel.v1 < maxv; rel.v1++)
      {
	// Do not repeat same question in a yes tree for an lta
	int flag=0;
        if (!class_tree)
	  {
	   for (int k = 1; k < vlist.dimx() && !flag; k+=2)
	     {
	       if (vlist(k)==rel.land1 && vlist(k+1)==rel.ang)
                                           flag=1;
	     }
	  }
          if (flag)
            continue;
	    if (index == qlist.dimx())
	      return;
	    else if (qlist(index) == counter++)
	    {
	      ltahist yes, no;
	      for (int i = 0; i < dlist.dimx(); ++i)
	      {
		if (check_q2(rel, lmarks[dlist(i)], instances[i]))
		  ++yes[lmarks[dlist(i)].truth(nist)];
		else
		  ++no[lmarks[dlist(i)].truth(nist)];
	      }
	      double newent;
	      if (class_tree==0)
		newent = 1000000 - yes.total();
              else
                newent = ave_impurity(yes, no);
	      if (newent < ent)
	      {
		ent = newent;
		que.typ = 2;
		que.r1 = rel;
	      }
	      ++index;
	    }
      }

} // get_best_q2

// __________________________________________________________________________



int check_q2(relation& rel, const landmarks& lmarks, const igrid& instances)
{


  int numinst = instances.dimy(); 
  int numland = lmarks.type_count(rel.land1);
  int numverts = instances.dimx() / 2;
  for (int i = 0; i < numinst; ++i)
  {
    int l1x = instances(rel.v1 * 2, i);
    int l1y = instances(rel.v1 * 2 + 1, i);
    for (int k = 0; k < numland; ++k)
    {
      int l2x = lmarks.location_x(rel.land1, k);
      int l2y = lmarks.location_y(rel.land1, k);
      int tooclose = 0;
      for (int j = 0; j < numverts && !tooclose; ++j)
      {
        int l0x = instances(2 * j, i);
        int l0y = instances(2 * j + 1, i);
        tooclose = (linfdist(l0x, l0y, l2x, l2y) < separation);
      }
      if (!tooclose && newcheck(l2x-l1x, l2y-l1y, rel))
        return 1;
    }
  }
  return 0;

} // check_q2

// __________________________________________________________________________
// Find all instances of a type 2 question

int upd_inst2(relation& rel, const landmarks&,
	      const igrid& oldinst, igrid& newinst)
{
  int i, j, k;
  int foundinst = 0;
  static igrid tmpinsts;
  static int inited = 0;
  if (!inited)
  {
    inited = 1;
    tmpinsts.init(3, q2insts);
  }

  int numinst = oldinst.dimy(); 
  int numverts = oldinst.dimx() / 2;
  for (i = 0; i < numinst; ++i)
  {
    int foundstar = 0;
    int l1x = oldinst(rel.v1 * 2, i);
    int l1y = oldinst(rel.v1 * 2 + 1, i);
    int searchpix = relmasksx(rel.ang, 0);
    for (k = 1; k < searchpix && foundinst < maxinst && !foundstar; ++k)
    {
      int l2x = l1x + relmasksx(rel.ang, k);
      int l2y = l1y + relmasksy(rel.ang, k);
      if (STAGS[rel.land1].get(l2x, l2y))
	//  if (edgemats[rel.land1].get(l2x, l2y))
      {
	int tooclose = 0;
	// Make sure the new location isn't too close to any other
        //   points in the current instance.
        if (separation)
	  {
	    for (j = 0; j < numverts && !tooclose; ++j)
	      {
		int l0x = oldinst(2 * j, i);
		int l0y = oldinst(2 * j + 1, i);
		tooclose = (linfdist(l0x, l0y, l2x, l2y) < separation);
	      }
	  }
	    int toonear = 0;
	// Make sure the new location isn't too close to other
	// locations already found for new vertex at current old-instance (i)
	for (j = 0; j < foundinst && !toonear && class_tree; ++j)
	  {
	    int l0x = tmpinsts(1, j);
	    int l0y = tmpinsts(2, j);
	    toonear = (linfdist(l0x, l0y, l2x, l2y) < ltasep);
	  }
	if (!tooclose && !toonear)
	{
	  tmpinsts(0, foundinst) = i;
	  tmpinsts(1, foundinst) = l2x;
	  tmpinsts(2, foundinst) = l2y;
	  ++foundinst;
	  if (!class_tree)
	  ++foundstar;
	}
      }
    }
  }

  if (foundinst)
  {
    newinst.init(oldinst.dimx() + 2, foundinst);
    for (j = 0; j < foundinst; ++j)
    {
      for (i = 0; i < oldinst.dimx(); ++i)
      {
	newinst(i, j) = oldinst(i, tmpinsts(0, j));
      }
      for (i = 0; i < 2; ++i)
	newinst(oldinst.dimx() + i, j) = tmpinsts(i + 1, j);
    }
  }
  else
    {
      if (class_tree)
	newinst = oldinst;
      else
	newinst.init();
    }
  return foundinst;
}
// __________________________________________________________________________
// q2.c
