// Copyright YALI AMIT, January 15, 2001.


// __________________________________________________________________________
// Includes

#include "includes.h"
#include "question.h"
#include "avlgrid.h"
#include "ltatree.h"
#include "globals.h"


extern ucgrids STAGS;
extern ucgrids edgemats;
// __________________________________________________________________________
// Function prototypes


int check_q5(relation& rel, const landmarks& lmarks,igrid& instances, int upd);
int newcheck(int dx, int dy, relation& rel);
// __________________________________________________________________________

void get_best_q5(question& que, lgrid& qlist, lgrid& dlist, 
		 const lmarkslist& lmarks, double& ent)
{

  if (qlist.dimx() == 0)
    return;
  igrid insts;
  int index = 0;
  int counter = 0;
  relation rel;
  for (rel.ang = minang; rel.ang < minang + numang; ++rel.ang)
    for (rel.tol = mintol; rel.tol < mintol + numtol; ++rel.tol)
      for (rel.dis = mindis; rel.dis < mindis + numdis; ++rel.dis)
	for (rel.land1 = minland; rel.land1 < minland + numland; ++rel.land1)
	   for (rel.land2 = minland; rel.land2 < minland + numland; ++rel.land2)
	  {
	    if (index == qlist.dimx())
	      return;
	    if (rel.land1 == rel.land2)
              continue;
	    else if (qlist(index) == counter++)
	    {
	      ltahist yes, no;
	      for (int i = 0; i < dlist.dimx(); ++i)
	      {
		if (check_q5(rel, lmarks[dlist(i)], insts, 0))
		  ++yes[lmarks[dlist(i)].truth(nist)];
		else
		  ++no[lmarks[dlist(i)].truth(nist)];
	      }

	      double newent;
	      if (class_tree==0)
		newent = 1000000 - yes.total();
              else
                newent = ave_impurity(yes, no);
	      if (newent < ent) {
		ent = newent;
		que.typ = 5;
		que.r1 = rel;
		if (no.total() == 0)
		  return;
	      }
	      ++index;
	    }
	  }

} // get_best_q1

// __________________________________________________________________________
// Determine if there is an instance of a type 1 question

int check_q5(relation& rel, const landmarks& lmarks,igrid& instances, int upd)
{


 static iavlgrid tmpinsts;
  static ivector l(4);
  
  static int inited = 0;
  if (!inited) 
    {
      inited = 1;
     
      tmpinsts.ainit(maxinst+1, 4);
     
    }
  else
    tmpinsts.reinit();
  int foundinst=0;
  int toomany=0;
  
  int num1 = lmarks.type_count(rel.land1);
  int num2 = lmarks.type_count(rel.land2);
 
  for (int i = 0; i < num1 && !toomany; ++i)
    for (int j = 0; j < num2 && !toomany; ++j)
    {
      l[0] = lmarks.location_x(rel.land1, i);
      l[1] = lmarks.location_y(rel.land1, i);
      l[2] = lmarks.location_x(rel.land2, j);
      l[3] = lmarks.location_y(rel.land2, j);

            

      int dx=l[2]-l[0];
      int dy=l[3]-l[1];
    
      if (newcheck(dx,dy,rel))
	{
	  if (!upd)
	    return 1;
	  else
	      {
		if (!tmpinsts.tooclose(l, ltasep))
		  {
		    for (int ii = 0; ii < 4; ++ii)
		      tmpinsts(foundinst, ii) = l[ii];
		    ++foundinst;        

		    if (foundinst>=maxinst)
		      toomany=1;    
		  }
	      }
     	}
    }

  if (!upd)
    return 0;
  else 
    {

      if (foundinst)
	{
	  instances.init(4, foundinst);
	  for (int i = 0; i < 4; ++i)
	    for (int j = 0; j < foundinst; ++j)
	      instances(i, j) = tmpinsts(j, i);
	}
      return(foundinst);
      // cout << " q3 " << instances.dimy() << endl;
    }

  
} // check_q5

