// Copyright YALI AMIT, January 15, 2001.

#ifndef QUESTION_H
#define QUESTION_H


#include <iostream>
#include <fstream>
#include <cstring>

#include "includes.h"
#include "grid.h"
//template<class T> class grid;
//typedef grid<int> igrid;

extern int numang, separation, near;
extern igrid relmasksx, relmasksy;

void make_rel_masks();
void view_rel_masks();

// __________________________________________________________________________
// relation = angle + tolerance + distance parameter along with the landmarks,
// graph index, or vertex or edge indices which are related

class relation
{
 public:
  char graph;
  int land1, land2;
  char v1, v2, v3, v4;
  char ang;  // 0, PI_4, ..., 7*PI_4
  char tol;  // PI_2, PI_4, PI_8, PI_16, PI_32
  char dis;  // 0, 1, or 2

  relation() { memset(this, 0, sizeof(relation)); }
  void read(istream& is) {  varread(is, graph); varread(is, land1);
			    varread(is, land2); varread(is, v1);
			    varread(is, v2); varread(is, v3);
			    varread(is, v4); varread(is, ang);
			    varread(is, tol); varread(is, dis); }
  void write(ostream& os) { varwrite(os, graph); varwrite(os, land1);
			    varwrite(os, land2); varwrite(os, v1);
			    varwrite(os, v2); varwrite(os, v3);
			    varwrite(os, v4); varwrite(os, ang);
			    varwrite(os, tol); varwrite(os, dis); }
  double relangle() { return ang * 2 * PI / numang; }
  double reltolerance() { return (2 * PI / numang); }
  inline int check(char x1, char y1, char x2, char y2);

}; // class relation




class question
{
 public:
  int typ;
  relation r1, r2;
  question() : typ(0) { }
  void write(ostream& os);
  void read(istream& is);
};

// __________________________________________________________________________
// question.h

#endif // QUESTION_H








