// Copyright YALI AMIT, January 15, 2001.


#ifndef SIMPSTRG_H
#define SIMPSTRG_H


// __________________________________________________________________________
// Include files

#include <iostream>
#include <cstring>
#include <fstream>
#include "includes.h"

// __________________________________________________________________________

class simpstrg
{

  friend ostream& operator<<(ostream& s, const simpstrg& x);

 private:
  char buf[256];
  unsigned char len;

 public:
  simpstrg() : len(0) { buf[0] = 0;}
  simpstrg(const simpstrg &s) : len(s.len) 
    { memcpy(buf, s.buf, len + 1); }
  simpstrg(const char* s) 
    { len = strlen(s); memcpy(buf, s, len + 1); }
  simpstrg& operator=(const simpstrg& s) { if (this != &s) 
    { len = s.len; memcpy(buf, s.buf, s.len + 1); } return *this; }
  simpstrg operator+(const simpstrg& s) const { simpstrg tmps;
    memcpy(tmps.buf, buf, len); memcpy(tmps.buf + len, s.buf, s.len + 1);
    tmps.len = len + s.len; return tmps; }
  int operator==(const simpstrg& s) const { if (this == &s) return 1;
    if (len != s.len) return 0;
    return (!memcmp(buf, s.buf, len)); }
  int operator==(const char* s) const {
    if (len != strlen(s)) return 0;
    return (!memcmp(buf, s, len)); }
  int operator!=(const simpstrg& s) const { return 1 - operator==(s); }
  int operator!=(const char* s) const { return 1 - operator==(s); }
  ~simpstrg() { }

  operator const char *() const { return buf; }

  void write(ofstream& ofs);
  void read(ifstream& ifs);

};

inline ostream& operator<<(ostream& s, const simpstrg& x)
{
   s << x.buf; 
   return s;
}

// __________________________________________________________________________
// simpstrg.h

#endif // SIMPSTRG_H

