// Copyright YALI AMIT, January 15, 2001.

#include <iostream>
#include <cstdio>
#include <fstream>
#include "includes.h"
#include "image.h"
#include "trainstat.h"
#include "detection.h"
#include "ltatree.h"
#include "viewgrid.h"
#include "viewport.h"
#include "globals.h"
#include "wave.h"
#include "graph.h"
#include "timer.h"

#define fmood(a, b) ( (a>=0) ? a : b+a)


Graph GR;

double ANGRA;
int gr = 1;
int ITER = 0;
int  prunenum;
int Msnum=0; 
float thresh = .15;

igrid first_result,clique,result,book_keepi,vert_list;
dgrid angll;
dgrid book_keepf,data;
dgrid var;
dgrid ucost;
dgrid out;

dgrid vert_d,vert_mat,dist_mat;
dgrid data_mat;
dgrid data_image;
int numvert,numdat;

int image_width;

double maxlog_vert,minlog_vert;
double BIG = 9999999;

int get_data(image &im);
void default_gr(ucgrid &gra);
void default_anl(dgrid &anl); 
void peel(int P,int givdat);
void Prune(int P,int nn,dgrid &value_list);
void prep();
void log_distances(dgrid &u,dgrid &u_mat,dgrid &v_mat);
int findmin(int num);
void find_cliques();
void find_sons(int i,int &n1,int &n2);
void display(viewport &vp, int text);

void display_data_points(viewport &vp);
void glob_cost();
void get_log_dif(int P,int n1,int n2,double *dis,double *dif,dgrid &mat);
void info(dgrid &ver,int p,int P,int n1,int n2,dgrid &ang,dgrid &angl,int FLAG);
void print_cost();
void save_s();
int find_result(int num);
void default_lim(dgrid &anl);

double  ange(dgrid &in, int i1, int i2, int i3, double &a1, double &a2);


double check_sym1(double cs1,double cs2,double cs3,dgrid &anl,int P);
double check_abso(double a1,double a2,double c2,dgrid &ag,dgrid &an,int P);
double EUC(double *a,double *b,int n);


double cost0(int dn,int in,int jn,int P,int n1,int n2,double *dif,double *mean,int p,dgrid &ang,dgrid &anl);
double checkang(double an,double cs,double anl1,double anl2,double flat);
double  ange(dgrid &in, int i1, int i2, int i3, double &a1, double &a2);
int check0(double *r,double *v,int P,dgrid &angl);

double find_peel(int bn,int n1,int n2);
double find_peelb(int bn,int n1,int n2,int P);
double deter(dgrid &ver, int i1, int i2, int i3);
double deter0(int d,int n1,int n2);
void findpoints(image &im, dgrid &lands);

void detectmasks(image &im, landmarks &ltaland);
extern ltatrees ltrees;
void extract_landmarks(image& im, ltatrees& ltrees, int numltas,
			 landmarks& edgelands, landmarks& ltalands);

void dy(image &im)
{

  im.normalize(255);
  image tim=im;
  tim.normalize(imrange*numcolors, (1-imrange)*numcolors-1);
  viewport vp(tim);

  if (!get_data(im))
    return;

  cout << " Got graph " << endl;
  image_width=im.dimx();
  prep();
  void display_template();
  
  
  if (dumpdetections==3)
    {
      display_template();
      display_data_points(vp);
    }

  ITER = 0;
  result.init(1,numvert);
  find_cliques();
  for (int P=0;P<numvert-2;P++) 
    {
      cout << "Vertex" << P << endl;
      result.clear(-1);
      /* Check if P is prefixed, if so skip the peel subroutine */
      timer timer1;
      timer1.restart();
      peel(P,-1);
      timer1.stop("Step ended");
      
      if (!find_result(P))
	return;
      
      if (dumpdetections==2) display(vp,0);
      
    }
  if (dumpdetections) display(vp,1);
  
  
  save_s();
  
  glob_cost();
  
  //  a2 = time(&b);
  
  
  
  
}


void glob_cost()
{

  
  dgrid ang_v(1, angll.dimy());
  dgrid al(1, GR.anglim.dimy());
  for (int i=0;i<6;i++) al(0,i) = 40./ANGRA;
  double sum = 0;
  double sumang = 0;
  for (int i=0;i<numvert-2;i++)
    {
      int i1 = result(0,i);
      for (int j=i+1;j<numvert-1;j++)
	{
	  int j1 = result(0,j);
	  for (int k=j+1;k<numvert;k++)
	    {
	      int k1 = result(0,k);
	      double dif[3],mean[3];
	      double d_dif[3],d_mean[3];
	      info(GR.vert,0,i,j,k,ang_v,al,0);
	      get_log_dif(i,j,k,mean,dif,vert_mat);
	      get_log_dif(i1,j1,k1,d_mean,d_dif,data_mat);
	      
	      double value = EUC(mean,d_mean,3);
	      sum += value;
	      /* Calculate ANG of angle 1 around `P'*/
	      double a1,a2;
	      double cs1 = ange(data,i1,j1,k1,a1,a2);
	      double valang = MIN(PI2-cs1,cs1)-MIN(PI2-ang_v(0,7),ang_v(0,7));
	      sumang+=valang*valang;
	      
	      
	      /* Calculate ANG of angle 2 around `in'*/
              double b1,b2;
	      double cs2 = ange(data,j1,i1,k1,b1,b2);
	      valang = MIN(PI2-cs2,cs2)-MIN(PI2-ang_v(0,8),ang_v(0,8));
	      sumang+=valang*valang;
	      
	      /* Calculate ANG of angle 3 around `jn'*/
              double c1,c2;
	      double cs3 = ange(data,k1,i1,j1,c1,c2);
	      valang = MIN(PI2-cs3,cs3)-MIN(PI2-ang_v(0,9),ang_v(0,9));
	      sumang+=valang*valang;
	      
	      
	    }
	}
    }
  
  printf("ANG -  %f \n",sumang);
  
}






void print_cost()
{

  double sum = 0;
  double sumang = 0;
  for (int P=0;P<=numvert-3;P++)
    {
      int n1 = clique(P,0);
      int n2 = clique(P,1);
      int in = result(0,n1);
      int jn = result(0,n2);
      int dn = result(0,P);
      double mean[3],dif[3],logdis[3];
      get_log_dif(P,n1,n2,mean,dif,vert_mat);
      get_log_dif(dn,in,jn,logdis,dif,data_mat);
      
      double value = EUC(mean,logdis,3);
      sum += value;
      /* Calculate ANG of angle 1 around `P'*/
      double a1,a2;
      double cs1 = ange(data,dn,in,jn,a1,a2);
      double valang = checkang(angll(P,7),cs1,GR.anglim(P,0),GR.anglim(P,1),angll(P,0));
      
      
      /* Calculate ANG of angle 2 around `in'*/
      double b1,b2;
      double cs2 = ange(data,in,dn,jn,b1,b2);
      valang += checkang(angll(P,8),cs2,GR.anglim(P,2),GR.anglim(P,3),angll(P,1));
      
      /* Calculate ANG of angle 3 around `jn'*/
      double c1,c2;
      double cs3 = ange(data,jn,dn,in,c1,c2);
      valang += checkang(angll(P,9),cs3,GR.anglim(P,2),GR.anglim(P,5),angll(P,2));
      
      
      
      
      valang += /* check_abso(a1,a2,c2,angll,GR.anglim,P)+*/ check_sym1(cs1,cs2,cs3,GR.anglim,P);
      
      sumang += valang;
    }
  
}



double check_sym1(double cs1,double cs2,double cs3,dgrid &anl,int P)
{
cs1 = MIN(PI2-cs1,cs1);
cs2 = MIN(PI2-cs2,cs2);
cs3 = MIN(PI2-cs3,cs3);
                     return(  anl(P,6)*(cs1-cs2)*(cs1-cs2)
                            + anl(P,7)*(cs2-cs3)*(cs2-cs3)
                            + anl(P,8)*(cs1-cs3)*(cs1-cs3)) ;
}


double check_abso(double a1,double a2,double c2,dgrid &ag,dgrid &an,int P)
{


  double aa1 = fmood(a1-ag(P,10),PI2);
  double aa2 = fmood(a2-ag(P,11),PI2);
  double cc2 = fmood(c2-ag(P,12),PI2); 
  aa1 = MIN(PI2-aa1,aa1);
  aa2 = MIN(PI2-aa2,aa2);
  cc2 = MIN(PI2-cc2,cc2);
  
  
  int logic =  ( (an(P,9)==0 || fabs(aa1) < an(P,9) ) &&
		 (an(P,10)==0 || fabs(aa2) < an(P,10)) &&
		 (an(P,11)==0 || fabs(cc2) < an(P,11)) );
  return( (float)logic);
}


double EUC(double *a,double *b,int n)
{
double r = 0;
 for (int i=0;i<n;i++)
   r += (a[i]-b[i])*(a[i]-b[i]);
return(r);
}

void get_log_dif(int P,int n1,int n2,double *dis,double *dif,dgrid &mat)
{
  dif[0] = mat(P,n1);
  dif[1] = mat(P,n2);
  dif[2] = mat(n1,n2);
  
  dis[0] = dif[0]-dif[1];
  dis[1] = dif[1]-dif[2];
  dis[2] = dif[2]-dif[0];
}







void save_s()
{

  ofstream ofs("out.asc");
  
  out.init(numvert,2);
  for (int i=0;i<numvert;i++)
    {
      int ni = result(0,i);
      out(i,0) = data(ni,0);
      out(i,1) = data(ni,1);
      
      
      ofs << data(ni,0) << " " << data(ni,1) << endl;
    }
  
}

// The vertices are peeled according to the order they are read in
//the list vert_file.
//When a vertex  P is being peeled its neighbours are listed in 
// clique.el[P][0,1] 

void peel(int P,int givdat)
{


double mean[3],dif[3];


/* Peeling vertex P */
int nn = numdat*numdat;
int count = 0;
dgrid value_list(1,nn);
/* Find the TWO neighbors of higher index number n1,n2 */
int n1 = clique(P,0);
int n2 = clique(P,1);

/* Intorduce colour checking */
int col0 = int(GR.vert(P,2));
int col1 = int(GR.vert(n1,2));
int col2 = int(GR.vert(n2,2));

/* Get log-distances between the 3 pairs of vertices in template */
/* Calculate differences (log of ratios) */

         get_log_dif(P,n1,n2,mean,dif,vert_mat);

/* Loop over pairs of data points which serve as candidates
for n1,n2 (in,jn)  to find which has best third candidate for P (dn).
The cost involves both the deviation from the shape of
(P,n1,n2) in template, AND previous costs incurred for
cliques involving the candidate pairs (dn,in), (dn,jn).
*/
int pn = 0;
for (int in=0;in<numdat;in++)
   {
for (int jn=0;jn<numdat;jn++)
    {

  /* Loop over candidate third points */
  double old_value = BIG;             
  int old_dn = -1;
     if ( (in != jn) && (col1==data(in,2)) && (col2==data(jn,2)) )
        {
        for(int dn=0;dn<numdat;dn++)
	  {
	    /* Can't have same point for two different vertices */
	    if ( (in!=dn) && (jn!=dn) && (col0==data(dn,2)) )
	      {
		/* Evaluate cost */
		double new_value = cost0(dn,in,jn,P,n1,n2,dif,mean,P,angll,GR.anglim);
		/* Check if less than smallest previous cost */
		if (new_value < BIG) 
		  count +=1;
		if (new_value<old_value)
		  {
		    old_value = new_value;
		    old_dn = dn;
		  }  /* End of value update if block */
	      } /* End of in=dn,jn=dn if blovk */
	  } /* End of dn loop */
	}/* End of in=jn if block*/
     /* Update book_keep matrices for this pair of data points and current
	vertex being peeled */
     book_keepf(pn,P) = old_value;
     value_list(0,pn) = old_value;
     book_keepi(pn,P) = old_dn;
     pn +=1;
    } /* End of jn loop */
 
   }
 
 
 cout << " Number of instances at node " << P << " is " << count << endl;


/* Sort list of values find prunnum-th best, cross out anything worse */
Prune(P,nn,value_list);


} /* End of Peel Subroutine */

static int compar(const void *a, const void* b)
{
  return (*((const double* )(a)) > *((const double*)(b)));
}

void Prune(int P,int nn,dgrid &value_list)
{


value_list.sort_columns(nn, compar);

if (prunenum==nn)
 prunenum=nn-1;

double ttr = value_list(0,prunenum);
for (int j=0;j<nn;j++)
{
if (book_keepf(j,P) > ttr) book_keepf(j,P) = BIG;
}

}

/* Cost evaluation subroutine */

double cost0(int dn,int in,int jn,int P,int n1,int n2,double *dif,double *mean,int p,
dgrid &ang,dgrid &anl)
{
  
  /* set cost at maximum value */
  double new_value = BIG;
  
  
  /* Calculate index of pairs (dn,in) and (dn,jn) in find_peel
     array, to obtain cost previously incurred in previously peeled cliques
     which contained either of the edges (P,n1), (P,n2) */
  int bni = dn*numdat+in;
  int bnj = dn*numdat+jn;
  double f1 = find_peel(bni,P,n1);
  double f2 = find_peel(bnj,P,n2);
  double f3 = find_peelb(in*numdat+jn,n1,n2,P);
  
  /* If both costs less than maximum proceed, otherwise the current
     triple (dn,in,jn) is impossible */
  if( (f1<BIG) && (f2 < BIG) && (f3<BIG) )
    {
      /* Get log distances of pairs of candidate data points
	 (in,jn,dn) from special array data_mat */
      double logdis[3], logdif[3];
      get_log_dif(dn,in,jn,logdis,logdif,data_mat);
      /* If rations of lengths of data p[airs to template pairs
	 is within determined margin proceed, otherwise rule triple out */
      if (check0(logdif,dif,P,anl))
	{
	  
	  
	  /* Calculate 3 angles in the triangle 'csi'
	     and absolute angles of edges x1,x2*/
	  double a1,a2;
	  double cs1 = ange(data,dn,in,jn,a1,a2);
	  double b1,b2;
	  double cs2 = ange(data,in,dn,jn,b1,b2);
	  double c1,c2;
	  double cs3 = ange(data,jn,dn,in,c1,c2);
	  
	  /* Check if calculated angles are in the correct range relative to
	     angles in template triangle. These are stored in angle.el */
	  double r1 = checkang(ang(p,7),cs1,anl(p,0),anl(p,1),ang(p,0));
	  double r2 = checkang(ang(p,8),cs2,anl(p,2),anl(p,3),ang(p,1));
	  double r3 = checkang(ang(p,9),cs3,anl(P,4),anl(P,5),ang(P,2));
	  
	  /* check_abso checks absolute angle of certain edges of triangles
	     to be in a certain range
	     eliminates rotation invariance of algorithm */
	  if ( r1>=0 && r2>=0 && r3>=0 && check_abso(a1,a2,c2,ang,anl,P)>0. )
	    { 
	      new_value = r1+r2+r3;
	      /*      check_sym1(cs1,cs2,cs3,anl,p)+
		      + EUC(logdis,mean,3);*/
	      
	      /* Add in incurred cost calculated above */
	      if (!ITER)  new_value += f1+f2+f3;
	    } /* End of checkang block */
	}   /* End of check0 block */
    }    /* End of if (f1,f2) block */
  return(new_value);
}



/* check  angles */
double checkang(double an,double cs,double anl1,double anl2,double flat)
{


 double  r = MIN(PI2-cs,cs)-MIN(PI2-an,an);
/* Flat triangle */
if (flat==0)
  {
  if (r<anl1 && r > -anl2)
    {
      double q = r*r;
      return(q);
    }
   else return(-1.);    
  }
else
  { 
   if( (cs > PI && an < PI) ||(cs < PI && an > PI)) return(-1);
   else 
   {
    if (r<anl1 && r > -anl2) return(r*r);
    else return(-1);
   }
  }
}
 


/* Calculate angle created by vertices v2,v1,v3 
 z1,z2 are inverse lengths of edges (v1,v2) (v1,v3) ,
prestored to save calcualtion */

double  ange(dgrid &in, int i1, int i2, int i3, double &a1, double &a2)
{
double dxa = in(i2,0)-in(i1,0);
double dya = in(i2,1)-in(i1,1);
double dxb = in(i3,0)-in(i1,0);
double dyb = in(i3,1)-in(i1,1);
double ana = atan2((int)(dya*image_width),(int)(dxa*image_width));
double anb = atan2((int)(dyb*image_width),(int)(dxb*image_width));
double an = fmood(ana-anb,PI2);
a1 = fmood(ana,PI2);
a2 = fmood(anb,PI2);
return(an);
}






/* Check if modulus of LOG length rations between data and template are
less than somje specified `scale_limit' */
int check0(double *r,double *v,int P,dgrid &angl)
{
 float s1,s2,s3;
 s1 = r[0] - v[0]; s2 = r[1] - v[1]; s3 = r[2] - v[2];
 return (  fabs(s1) < angl(P,angl.dimy()-3)
       &&  fabs(s2) < angl(P,angl.dimy()-2)
       &&  fabs(s3) < angl(P,angl.dimy()-1) );
 }



/* Go bakcwards and find optimal choices for each vertex */
int find_result(int num) 
{

  /* Find best pair for last peeled vertex */
  if (!findmin(num))
        return(0);
  /* For each vertex P < num find the TWO neighbors of higher index number n1,n2 
     (onto which P has been peeled
     Find their datapoints. Go to that pair in book_keep to get data point
     for P */
  for (int P=num;P>=0;P--)
    {
      int  n1 = clique(P,0);
      int  n2 = clique(P,1);
      
      /* Already identified because  n1,n2>P*/
      int m1 = result(0,n1);
      int m2 = result(0,n2);
      
      /*  printf("m1 - %d,m2 - %d\n",m1,m2);*/
      if ( m1>=0 && m2>=0 )
	{
	  int dn = m1*numdat+m2;

	  if (result(0,P)<0)
	    result(0,P) = book_keepi(dn,P);
	}
    }

return(1);  
}

 

/* Read in parameter file andcandidate location files */
int get_data(image &im)
{
  
  ANGRA = 180./PI;

  if (GR.graph.dimx()==0)
    {
      simpstrg filn = maskdir+simpstrg("/")+tempfile;
      ifstream ifs(filn);
      GR.read(ifs, ANGRA);
    }
  numvert=GR.vert.dimx();
  // Read in sequence of points which are the verticies of the graph

  
  /* Get landmark candidates */
  dgrid temp;
  findpoints(im, temp);
  

  if (temp.dimx()==0)
    {
      cout << " No local features found " << endl;
      return 0;
    }
  numdat=temp.dimx();
  data.init(temp.dimx(),temp.dimy());
  data.subcopy(0,temp.dimx(),0,temp.dimy(),temp,0,0);
  
  // Pruning number, number of possiblities to keep 
  numdat = data.dimx();
  
  cout << "Number of local features " << numdat << endl;
  
  prunenum = (int)(GR.prune*numdat*numdat);
  return 1;
}





void prep()
{

vert_mat.init(GR.vert.dimx(),GR.vert.dimx());
vert_d.init(GR.vert.dimx(),GR.vert.dimx());
// Find the log-distances and inverse distances for all pairs of
// GR.vertices in graph, actually only needed along edges 

log_distances(GR.vert,vert_d,vert_mat);


/* Do the same for all pairs of data points */
data_mat.init(data.dimx(), data.dimx());
dist_mat.init(data.dimx(), data.dimx());
log_distances(data,dist_mat,data_mat);

// Book Keeping matrix 
// book_keep matrices have as many rows as paitrs of data points
//and as many columns as vertices on the graph. 
//For each pair of data points 
//book_keepi[][P] : denotes the index of the best third data point for
//                  matching the triangle for which P is at the top,
//                  (at angle 1).
//book_keepf[][P] : denotes the cost of the best third data point for
//                  matching the triangle for which P is at the top,
//                  (at angle 1).

book_keepf.init(numdat*numdat,numvert);
book_keepf.clear();
book_keepi.init(numdat*numdat, numvert);


}



// Calculate log-distances and inverses of distances between pairs of
// points in u 
void log_distances(dgrid &u,dgrid &u_mat,dgrid &v_mat)
{

  for (int i=0;i<u.dimx();i++)
    for (int j=0;j<u.dimx();j++)
      {
	if (i!=j){
	  double dis = (u(i,0)-u(j,0))*(u(i,0)-u(j,0))+(u(i,1)-u(j,1))*(u(i,1)-u(j,1));
	  u_mat(i,j) = 1./sqrt(dis);
	  v_mat(i,j) = .5*log(dis);
	}
	else
	  {
	    u_mat(i,j) = 1;
	    v_mat(i,j) = 1;
	  }
      }
}


//  At each stage of the peeling procedure find
// the best triangle for the clique corresponding to 
// `num', and reconstruct then go back to find_result to reconstruct
// the optimal chioces for the matching up to vertex `num' 

int findmin(int num)
{
  float find_peel();
  int P = num;
  int n1 = clique(P,0);
  int n2 = clique(P,1);
  double old = BIG;             
  int FIX1 = -1;	
  int FIX2 = -1;
  int npold=-1;
  // If certain laocations are fixed in advance there should
  //be apositive value in the corresponding place in result 
  
  
  
  if (result(0,n1)>0) FIX1 = result(0,n1);
  if (result(0,n2)>0) FIX2 = result(0,n2);
  int old1 = FIX1;
  int old2 = FIX2;
  
  
  
  if ( (FIX1<0) || (FIX2 < 0) )
    {
      int np = 0; 
      for(int i=0;i<numdat;i++)
	{ 
	  if( (FIX1<0) || (i==FIX1))
	    {
	      for(int j=0;j<numdat;j++)
		{
		  if( (FIX2<0) || (j==FIX2))
		    {
		      double newv = book_keepf(np+j,P);
		      if (newv < old)
			{
			  old = newv;
			  old1 = i;
			  old2 = j;
			  npold = np+j;
			}
		    }
		}
	    }
	  np += numdat;
	}
    }
  else
    {
      old = book_keepf(old1*numdat+old2,P);
    }
  if (old < BIG)
    {
      cout << " Current cost is " << old << endl;
      result(0,n1) = old1;
      result(0,n2) = old2;
      result(0,P) = book_keepi(npold,P);
    }
  else
    {
      printf("ANG - -1\n");
      return(0);
    }
  return(1);
}



// Find peeled values on edge bn for vertices (n1,n2) of template graph
double find_peel(int bn,int n1,int n2)
{


double t = 0;
int realk = -1;

for (int k=0;k<n1;k++)
  {
    //Both conditions have to be true for k to have been peeled */
    // Get the cost of the (n1,n2) = bn option */
      if ( GR.graph(n1,k) && GR.graph(n2,k) ) realk = k;
  }
 if (realk>=0) t = book_keepf(bn,realk);
 return(t);

}

double find_peelb(int bn,int n1,int n2,int P)
{
  double  t=0;
  int realk=-1;

  for (int k=0;k<P;k++)
    {
      // Both conditions have to be true for k to have been peeled 
      // Get the cost of the (n1,n2) = bn option 
      if ( GR.graph(n1,k) && GR.graph(n2,k) ) 
	realk = k;
    }
  if (realk>=0) t = book_keepf(bn,realk);
  return(t);
  
}




// Find cliques, triangles corresponding to each vertex in the peeling
// order, and data on angles of these triangles 
void find_cliques()
{

  clique.init(numvert-2,3);
  angll.init(numvert-2,13);
  for (int P=0;P<numvert-2;P++)
    {
      int n1,n2;
      find_sons(P,n1,n2);
      clique(P,0) = n1;
      clique(P,1) = n2;
      info(GR.vert,P,P,n1,n2,angll,GR.anglim,0);
    }
}



 
void info(dgrid &ver,int p,int P,int n1,int n2,dgrid &ang,dgrid &angl,int FLAG)
{
  double r = deter(ver,P,n1,n2);
  if ( r<thresh && r> -thresh) {  ang(p,0) = 0; ang(p,4) = 0;}
  else { ang(p,0) = r; ang(p,4) = 1./r;}
  
  
  /* SIN of angle 2 */
  r = deter(ver,n1,P,n2);
  if ( r<thresh && r> -thresh) {  ang(p,1) = 0; ang(p,5) = 0;}
  else { ang(p,1) = r; ang(p,5) = 1./r;}
  
  /* SIN of ange 3 */
  r = deter(ver,n2,P,n1);
  if ( r<thresh && r> -thresh) {ang(p,2) = 0; ang(p,6) = 0;}
  else {ang(p,2) = r; ang(p,6) = 1./r;}
  
  /* Store   angle 1*/
  double a1,a2;
  r = ange(ver,P,n1,n2,a1,a2);
  ang(p,7) = r;
  /* Store   angle 2*/
  double b1,b2;
  r = ange(ver,n1,P,n2,b1,b2);
  ang(p,8) = r;
  /* Store   angle 3*/
  double c1,c2;
  r = ange(ver,n2,P,n1,c1,c2);
  ang(p,9) = r;
  ang(p,10) = a1;
  ang(p,11) = a2;
  ang(p,12) = c2;
  
  if (FLAG)
    {
      printf("%d  %d  %d \n",P,n1,n2);
      printf(" Sines - %f %f %f \n",ang(p,0),ang(p,1),ang(p,2));
      printf(" Angles 1 -  %f 2 - %f 3 - %f\n",ang(p,7)*ANGRA,ang(p,8)*ANGRA,ang(p,9)*ANGRA); 
      printf(" Angles a1 -  %f a2 - %f c - %f \n ",ang(p,10)*ANGRA,ang(p,11)*ANGRA,ang(p,12)*ANGRA); 
      /*
	printf(" Anglim 1 -  %f 1 - %f 2 - %f 2 - %f 3 - %f 3 - %f\n",angl(p,0)*ANGRA,angl(p,1)*ANGRA,angl(p,2)*ANGRA,angl(p,3)*ANGRA,angl(p,4)*ANGRA,angl(p,5)*ANGRA); 
      */
    }
  
}

/* Find the two neighbors of higher index number */
void find_sons(int i,int &n1,int &n2)
{
  
  int k=i+1;
  // Find two points beneath i with edge to i 
  while(GR.graph(i,k)==0) k=k+1;
  n1 = k;
  k=k+1;
  while(GR.graph(i,k)==0) k=k+1;
  n2 = k;
  
}



/*Get SIN of angle between points v1,v2,v3 */
double deter(dgrid &ver, int i1, int i2, int i3)
{

 double x1 = ver(i1,0)-ver(i2,0);
 double y1 = ver(i1,1)-ver(i2,1);
 double x2 = ver(i1,0)-ver(i3,0);
 double y2 = ver(i1,1)-ver(i3,1);
 double r = x1*y2-x2*y1;
 double z = sqrt(x1*x1+y1*y1)*sqrt(x2*x2+y2*y2);
 r = r/z;
 return(r);
}

/* Get SIN of angle between data points d,n1,n2 */
double deter0(int d,int n1,int n2) 
{
  double x1 = data(d,0) - data(n1,0);
  double y1 = data(d,1) - data(n1,1);
  double x2 = data(d,0) - data(n2,0);
  double y2 = data(d,1) - data(n2,1);
  double r = x1*y2-x2*y1;
  double z = dist_mat(d,n1)*dist_mat(d,n2);
  r = r*z;
  return(r);
}

void display_template()
{

  image tim(DIMX, DIMX);
  tim.clear(imrange*numcolors);
  viewport vp(tim);
  for (int i=0;i<numvert;i++)
    {
      for (int j=0;j<numvert;j++)
	{   
	  if ( GR.graph(i,j) )
	    {
	      vp.add_line(GR.vert(i,0)*DIMX,GR.vert(i,1)*DIMX,
			  GR.vert(j,0)*DIMX,GR.vert(j,1)*DIMX, basecol);
	
	    }
	} /* end j loop */
    } /* end if ni */
  
    for (int i=0;i<numvert;i++)
      {
	vp.add_string(GR.vert(i,0)*DIMX,GR.vert(i,1)*DIMX,ltos(i),7 /*numcolors-basecol*/);
          //vp.add_point(GR.vert(i,0)*DIMX,GR.vert(i,1)*DIMX,numcolors-basecol,4);
      }
  vp.view();
  
}


void display(viewport &vp, int text)
{

  vp.clear_geom();
  for (int i=0;i<numvert;i++)
    {
      int ni = result(0,i);
      if (ni >= 0 )
	{
	  for (int j=0;j<numvert;j++)
	    {   
	      if ( GR.graph(i,j) )
		{
		  int nj = result(0,j);
		  if (nj >= 0 )
		    {
		      if (!text)
			{
			  vp.add_line(data(ni,0)*image_width,
				      data(ni,1)*image_width,
				      data(nj,0)*image_width,
				      data(nj,1)*image_width, basecol);
			}
		     
		    } /* End nj>=0 */
		} /* graph(i,j) */
	    } /* end j loop */
	} /* end if ni */
    }
  


if (text)
  {
    for (int i=0;i<numvert;i++)
      {
	int ni = result(0,i);
	vp.add_point(data(ni,0)*image_width,data(ni,1)*image_width,basecol,3);
	vp.add_string(data(ni,0)*image_width,data(ni,1)*image_width,ltos(i),basecol);
      }
  }  
  vp.view();  
}



void display_data_points(viewport &vp)
{
 
  data.dump();
  vp.clear_geom();
 for (int j=1; j<=Msnum; j++)
   {
     vp.clear_geom();
     for (int i=0;i<numdat;i++)
       {
      if (data(i,2)==j)
	//vp.add_point(data(i,0)*image_width, data(i,1)*image_width,j);
	 vp.add_point(data(i,0)*image_width, data(i,1)*image_width,basecol,3);      
       }
  vp.view();
   }
  

  
}






void findpoints(image &im, dgrid &lands)
{


  landmarks edgelands;
  landmarks ltalands;
  if (usemasks)
    detectmasks(im, ltalands);
  else
    extract_landmarks(im, ltrees, numltas, edgelands, ltalands);
 

 Msnum=ltalands.total_types();
 lands.init(ltalands.total_instances(),3);
 int p=0;
 for (int k=0; k<ltalands.total_types(); k++)
   for (int j=0; j<ltalands.type_count(k); j++)
     {
       lands(p,0)=ltalands.location_x(k,j)/(double)(im.dimx());;
       lands(p,1)=ltalands.location_y(k,j)/(double)(im.dimx());
       lands(p,2)=k+1;
       p++;
     }
 
}







