// Copyright YALI AMIT, January 15, 2001.

#ifndef FACES_H
#define FACES_H


template<class T> class vector;
template<class T> class grid;

typedef grid<unsigned char> ucgrid;
typedef grid<int> igrid;
typedef grid<double> dgrid;
typedef vector<ucgrid> ucgrids;
typedef vector<ucgrids> ucgridss;
typedef vector<dgrid> dgrids;



class carttree;
class ltatree;

// __________________________________________________________________________

void make_procmask(ucgrid& processmask, int masktype, int sx, int sy);
void write_dgrids(dgrids& regims, int first, int numdigits, char* name);
int read_coords(igrid& left, igrid& right, igrid& mouth, double scale, int ff, int ll);
void get_mean_edgemap();
void get_lta_maps();
void get_coord_stats();
void register_images();
void make_edge_maps();
void transform_edge_maps();
double l2_normalize(dgrid& d, const ucgrid& pmask);
void make_latex_images();
void make_ltas();
void find_ltas();
void find_mean_face();
void edges_to_ltas(landmarks& edgelands, landmarks& ltalands, 
		   const ltatree *ltrees, int numltas);
void view_lta_locations();
void view_ltas();
void make_cart_train_good(dgrids& cartims, ucgridss& lands);
void get_cart_train_good(dgrids& cartims, ucgridss& lands, int cstyle,
                         const char* cfr = "cartraw", 
                         int cstart = 0, int nd = 1);
void get_cart_train_bad(dgrids& cartims, int curriter, 
			const carttree* ctrees, ucgridss& lands);
void grow_cart_trees();
void test_images();

// __________________________________________________________________________
// faces.h
#endif
