// Copyright YALI AMIT, January 15, 2001.

#ifndef VECTOR_H
#define VECTOR_H

// __________________________________________________________________________
// Basic 1-dimensional array

#include <cassert>

template <class T>
class vector
{
 private:
  int nx;
  T* sto;

  vector(const vector& v);
  void operator=(const vector& v);

 public:
  vector(int x = 0) : nx(x) { assert(x >= 0); sto = (x == 0 ? 0 : new T[x]); }
  ~vector() { delete [] sto; }

  int dim() const { return nx; }
  void init(int x = 0) { assert(x >= 0);
    if (sto != 0) delete [] sto; nx = x; sto = (x == 0 ? 0 : new T[x]); 
  }
  operator T*() const { return sto; }
  T& operator[](int x) const { assert(x >= 0 && x < nx); return sto[x]; }
  T& operator()(int x) const { assert(x >= 0 && x < nx); return sto[x]; }

}; // class vector

// __________________________________________________________________________
// Basic defines

typedef vector<char> cvector;
typedef vector<unsigned char> ucvector;
typedef vector<int> ivector;
typedef vector<unsigned int> uivector;
typedef vector<long> lvector;
typedef vector<float> fvector;
typedef vector<double> dvector;

// __________________________________________________________________________
// vector.h

#endif
