// Copyright YALI AMIT, January 15, 2001.

#include <iostream>
#include <cstdio>

#include "includes.h"
#include "image.h"
#include "globals.h"
#include "wave.h"

#define pint(a) ( (a>=0) ? ((int)(a)) : ((int)(a)-1) )

int mood(int a,int b)
{
if (a>=0)
  return(a%b);
else
  return ( (b-(abs(a)%b)) % b );

}

dgrid low,high,invlow,invhigh;

double vec[43] = 
{.7071068,
.7071068,
.482962913145,
.836516303738,
.224143868042,
-.129409522551,
.332670552950,
.806891509311,
.459877502118,
-.135011020010,
-.085441273882,
.035226291882,
.230377813309,
.714846570553,
.630880767930,
-.027983769417,
-.187034811719,
.030841381836,
.032883011667,
-.010597401785,
.160102397974,
.603829269797,
.724308528438,
.138428145901,
-.242294887066,
-.032244869585,
.077571493840,
-.006241490213,
-.012580751999,
.003335725285,
.111540743350,
.494623890398,
.751133908021,
.315250351709,
-.226264693965,
-.129766867567,
.097501605587,
.027522865530,
-.031582039318,
.000553842201,
.004777257511,
-.001077301085,  
};

void makevec(int N)
{

  if (N==0)
    return;
int c,j,p,i,si;

j = 0;

/*calculate pointer in vector for required coefficients */
if (N>1)
  {
    j=2;
    c = 2;
    while (c<N)
      {
	j = j + c+c;
	c = c+1;
      }
  }
p = j;
/* create the two filters */
high.init(2*N);
low.init(2*N);
invhigh.init(2*N);
invlow.init(2*N);
/* Averaging filter (low pass) */
for (i=0;i<=2*N-1;i++)
  low(i)=vec[p+i];

/* Difference filter (band pass) */
si = 1;
for (i=0;i<=2*N-1;i++)
  {
    high(i)=si*low(2*N-1-i);
    si = -si;
  }

/* create filters for inverse transform*/
for (i=0;i<=N-1;i++)
  {
    invlow(i)=low(2*i);
    invlow(N+i)=low(2*i+1);
    invhigh(i) = high(2*i);
    invhigh(N+i) = high(2*i+1);
  }


}

void transp(dgrid &ptrin,dgrid &ptrout, int B, int R)
{

for (int i=B;i<R;i++)
  for (int j=B;j<R;j++)
    ptrout(i,j) = ptrin(j,i);

}

void copy_p(dgrid &ptrin,dgrid &ptrout, int B, int R)
{

for (int i=B;i<R;i++)
  for (int j=B;j<R;j++)
    ptrout(i,j) = ptrin(i,j);

}

void wavep2(dgrid &data,int number)
{
int L = data.dimx();
int B = 0;

while(L-B > number)
  {
    dgrid temp(data.dimx(),data.dimy());
    temp.clear();
    for (int i=B; i<L; i++)
      conv1(data, temp, B, L, i);

    transp(temp,data,B,L);

    temp.clear();
    for (int i=B; i<L; i++)
      conv1(data, temp, B, L, i);

    copy_p(temp,data,B,L);

    B = B + (L-B)/2;

  }

}

void wavep1(dgrid &data,int number)
{

  if (base==0)
    return;
int L = data.dimy();

int B = 0;

while(L-B > number)
{
  dgrid temp(1,data.dimy());
  temp.clear();

  conv1(data,temp,B,L,0);

  for (int l=B;l < L;l++) 
    data(0,l) = temp(0,l);
  B = B + (L-B)/2;

}

}

void conv1(dgrid &data, dgrid &temp,  int B, int R, int i)
{
int j,k;

int len = high.dimx();

int H = R-B;
int num2 = H/2 -1;

    int j1 = B-1;
    int j2 = B + num2;
    for (j=0; j<H; j += 2) 
      {
	j1 += 1;
	j2 +=1;
	for (k=0 ; k<len; k++)
	  {
	    int jk = B + ((j+k) % H);
	    temp(i,j1) += data(i,jk)*high(k);
	    temp(i,j2) += data(i,jk)*low(k);
	  }
      }

}

void unwavep2(dgrid &data,int number)
{

int L = data.dimx();
int B = L-2*number;
while(B >= 0)
  {

   dgrid temp(data.dimx(),data.dimy());
   temp.clear();
   for (int i=B; i<L; i++)
     convt1(data, temp, B, L, i);

   transp(temp,data,B,L);
   temp.clear();

   for (int i=B; i<L; i++)
     convt1(data, temp, B, L, i);
   copy_p(temp,data,B,L);

   B = 2*B - L;
  }

}

void unwavep1(dgrid &data,int number)
{

  if (base==0)
    return;

int L = data.dimy();
int B = L-2*number;
while(B >= 0)
  {
    dgrid temp(1,data.dimy());
    temp.clear();

    convt1(data,temp,B,L,0);
    for (int l=B;l<L;l++) 
      data(0,l)=temp(0,l);
    B = 2*B - L;

  }
}

void matiid(dgrid &e)
{
double a,b,mag;
int max = 1234;
int i, j;
  for ( i=0; i < e.dimx(); i++)
    {
     for (j=0; j < e.dimy()-1; j+=2)
        { a =  (0.5 + (rand() % max) )/max;
          b = PI2*(0.5+ (rand() % max) )/max;
          mag = sqrt(-2.0*log(a));
          e(i,j) = (float)mag*sin(b);
          e(i,j+1) = (float)mag*cos(b);
        }
     }   
}

void convt1(dgrid &data, dgrid &temp, int B,int R, int i)
{

int len2 = low.dimx()/2;

int num2 = (R-B)/2;
int j1 = B;
for (int j=0; j<num2; j++) 
  {
    for (int k=0; k<len2; k++)
      {
	int jk1 = B+ mood((j-k),num2);
	int jk2 = num2 + jk1;
	int kl2 = k+len2;
	temp(i,j1)+=data(i,jk1)*invhigh(k)+data(i,jk2)*invlow(k);
	temp(i,j1+1)+=data(i,jk1)*invhigh(kl2)+data(i,jk2)*invlow(kl2);
      }
    j1 += 2;
  }

}

void applyuv_smt1(dgrid &u, dgrid &v, dgrid &I, dgrid &hI, int bs1,int bs2)
{

int n1 = hI.dimx();
int n2 = hI.dimy();
int m1 = I.dimx();
int m2 = I.dimy();
for (int i = 0; i< u.dimx(); i ++)
  for(int j = 0; j < u.dimy(); j ++ )
    {
      double a = n1*u(i,j);
      double b = n2*v(i,j);
      int xx = i+ pint(a);
      int yy = j+ pint(b);
      int xx1 = xx+1; int yy1 = yy+1;
      a = a-pint(a);
      b = b-pint(b);
      xx = MAX(0,MIN(bs1+xx,m1-1));
      yy =  MAX(0,MIN(bs2+yy,m2-1));
      xx1 = MAX(0,MIN(bs1+xx1,m1-1));
      yy1 = MAX(0,MIN(bs2+yy1,m2-1));

      hI(i,j) = a*b*I(xx1,yy1)+(1.-a)*b*I(xx,yy1)
	+(1.-b)*a*I(xx1,yy)+(1.-b)*(1.-a)*I(xx,yy);
    }
}

void match_points(dgrid &u, dgrid &v, int bs1,int bs2, igrid &in, igrid &out)
{

int n1 = u.dimx();
int n2 = u.dimy();

out.clear(-1);
for (int i = 0; i< u.dimx(); i ++)
  for(int j = 0; j < u.dimy(); j ++ )
    {
      double a = n1*u(i,j);
      double b = n2*v(i,j);
      int xx = bs1 + i+ pint(a);
      int yy = bs2 + j+ pint(b);
      int found=0;
      for (int s=0; s<in.dimx() && !found;s++)
	{
          double r=fabs(xx-in(s,0))+fabs(yy-in(s,1));
	  if ( r < 2. && out(s,0) <0 )
            {
              found=1;
              out(s,0)=i;
              out(s,1)=j ;
            }
	}
    }
}
/***********************************************************************
 * Computes discrete horizontal and vertical gradient of Amat.
 * Places results in Hmat and Vmat.
 * Assumes a square matrix Amat, and that Hmat and Vmat already exist.
 */ 
void GRADIENT(dgrid &Amat, dgrid &Hmat, dgrid &Vmat)
{

double NH = Amat.dimx();
double NV = Amat.dimy();
Hmat.clear();
Vmat.clear();
for (int i=1; i<Amat.dimx()-1; i++)
   for (int j=1; j<Amat.dimy()-1; j++)
     {
      Hmat(i,j)=.5*(Amat.get(i+1,j)-Amat.get(i-1,j))*NH;
      Vmat(i,j)=.5*(Amat.get(i,j+1)-Amat.get(i,j-1))*NV;
      }

}

void blur_subsample(dgrid &th, double ratio, double sd)
{
  if (ratio == 1.0)
    return;

  static int filt_made = 0;
  static dgrid filt;

  // Make the filter if necessary.
  if (!filt_made)
  {
    int i, j;
    // Calculate a truncated Gaussian convolution filter
    filt_made = 1;
    int center = filter_size / 2;
    filt.init(filter_size, filter_size);
    for (i = 0; i < filter_size; ++i)
      for (j = 0; j < filter_size; ++j)
	filt(i, j) = exp(-1 * ((i - center) * (i - center) + 
				 (j - center) * (j - center)) / (sd * sd));

    // Normalize the truncated filter so that it has norm 1.
    double sum = 0;
    for (i = 0; i < filter_size; i++)
      for (j = 0; j < filter_size; j++)
	sum += filt(i,j);
    for (i = 0; i < filter_size; ++i)
      for (j = 0; j < filter_size; ++j)
	filt(i, j) /= sum;
  }

  // Convolve and downscale the original image
  int newx = int(th.dimx() * ratio + FUZZ);
  int newy = int(th.dimy() * ratio + FUZZ);
  dgrid fnum(newx, newy);
  int i;
  for (i=0; i < newx; i++)
    for (int j=0; j < newy; j++)
    {
      int oldx = int(i / ratio + FUZZ);
      int oldy = int(j / ratio + FUZZ);
      double total=0;
      for (int k = 0; k < filt.dimx(); k++)
        for (int l = 0; l < filt.dimy(); l++)
         total += th.get(oldx + k, oldy + l) * filt(k, l);
      fnum(i, j) = total;
    }

  th.init(fnum.dimx(), fnum.dimy());
  for (i=0; i < th.dimx(); i++)
    for (int j=0; j < th.dimy(); j++)
      th(i, j) = double(fnum(i, j));

} // image::blur_downscale

void makewaves()
{
  makevec(base);
  // Create wavelet functions
  int dimx=LASTDIM;
  dgrid temp(1,dimx);

  // Loop through all standard basis vectors and apply inverse transform
  int dd2=0;
  for (int dd=1; dd<=dimx; dd*=2)
    {
      for (int l=dimx-dd; l<dimx-dd2; l++)
	{
	  temp.clear(0);
	  temp(l)=1;
	  unwavep1(temp,1);
	  temp.dump();
	}
      dd2=dd;
    }

}
